# LuxurySparse.jl

[![Build Status](https://github.com/QuantumBFS/LuxurySparse.jl/workflows/CI/badge.svg)](https://github.com/QuantumBFS/LuxurySparse.jl/actions)
[![Codecov](https://codecov.io/gh/QuantumBFS/LuxurySparse.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/QuantumBFS/LuxurySparse.jl)

High performance extension for sparse matrices.

## Contents
* General Permutation Matrix `PermMatrix`,
* Identity Matrix `IMatrix`,
* Coordinate Format Matrix `SparseMatrixCOO`,
* Static Matrices `SSparseMatrixCSC`, `SPermMatrix` et. al.

with high performance type conversion, `kron`, and multiplication operations.

## Installation
Install with the package manager, `pkg> add LuxurySparse`.

## Usage

```julia
using SparseArrays, LuxurySparse, BenchmarkTools

pm = pmrand(7)  # a random permutation matrix
id = IMatrix(3) # an identity matrix
@btime fastkron(pm, id)   # 96.606 ns

Spm = pm |> SparseMatrixCSC  # convert to SparseMatrixCSC
Sid = id |> SparseMatrixCSC
@btime kron(Spm, Sid)     # 388.817 ns

spm = pm |> staticize        # convert to static matrix, notice that `id` is already static.
@btime fastkron(spm, spm)    # 104.581 ns
@btime fastkron(pm, pm)      # 146.484 ns
```

For more information, please refer the latest [Documentation](https://quantumbfs.github.io/LuxurySparse.jl/latest/).

## Planned features
* Change `PermMatrix` to column major
* Better support of conversion to static matrices

function irepeat(v::AbstractVector, n::Int)
    nV = length(v)
    res = similar(v, nV * n)
    @inbounds for j = 1:nV
        vj = v[j]
        base = (j - 1) * n
        @inbounds @simd for i = 1:n
            res[base+i] = vj
        end
    end
    res
end

function orepeat(v::AbstractVector, n::Int)
    nV = length(v)
    res = similar(v, nV * n)
    @inbounds for i = 1:n
        base = (i - 1) * nV
        @inbounds @simd for j = 1:nV
            res[base+j] = v[j]
        end
    end
    res
end


####### kronecker product ###########
fastkron(a, b) = kron(a, b)
fastkron(A::Diagonal{<:Number}, B::SparseMatrixCSC{<:Number}) = kron(PermMatrixCSC(A), B)
fastkron(A::SparseMatrixCSC{<:Number}, B::Diagonal{<:Number}) = kron(A, PermMatrixCSC(B))
fastkron(A::Diagonal{<:Number}, B::StridedMatrix{<:Number}) = kron(PermMatrixCSC(A), B)
fastkron(A::StridedMatrix{<:Number}, B::Diagonal{<:Number}) = kron(A, PermMatrixCSC(B))

LinearAlgebra.kron(A::IMatrix{Ta}, B::IMatrix{Tb}) where {Ta<:Number,Tb<:Number} =
    IMatrix{promote_type(Ta, Tb)}(A.n * B.n)
LinearAlgebra.kron(A::IMatrix{<:Number}, B::Diagonal{<:Number}) = A.n == 1 ? B : Diagonal(orepeat(B.diag, A.n))
LinearAlgebra.kron(B::Diagonal{<:Number}, A::IMatrix) = A.n == 1 ? B : Diagonal(irepeat(B.diag, A.n))

function LinearAlgebra.kron(A::AbstractMatrix{Tv}, B::IMatrix) where {Tv<:Number}
    B.n == 1 && return A
    mA, nA = size(A)
    nzval = Vector{Tv}(undef, B.n * mA * nA)
    rowval = Vector{Int}(undef, B.n * mA * nA)
    colptr = collect(1:mA:B.n*mA*nA+1)
    @inbounds for j = 1:nA
        source = view(A, :, j)
        startbase = (j - 1) * B.n * mA - mA
        for j2 = 1:B.n
            start = startbase + j2 * mA
            row = j2 - B.n
            @inbounds @simd for i = 1:mA
                nzval[start+i] = source[i]
                rowval[start+i] = row + B.n * i
            end
        end
    end
    SparseMatrixCSC(mA * B.n, nA * B.n, colptr, rowval, nzval)
end

function LinearAlgebra.kron(A::IMatrix, B::AbstractMatrix{Tv}) where {Tv<:Number}
    A.n == 1 && return B
    mB, nB = size(B)
    rowval = Vector{Int}(undef, nB * mB * A.n)
    nzval = Vector{Tv}(undef, nB * mB * A.n)
    @inbounds for j = 1:A.n
        r0 = (j - 1) * mB
        for j2 = 1:nB
            start = ((j - 1) * nB + j2 - 1) * mB
            @inbounds @simd for i = 1:mB
                rowval[start+i] = r0 + i
                nzval[start+i] = B[i, j2]
            end
        end
    end
    colptr = collect(1:mB:nB*mB*A.n+1)
    SparseMatrixCSC(mB * A.n, A.n * nB, colptr, rowval, nzval)
end

function LinearAlgebra.kron(A::IMatrix, B::SparseMatrixCSC{T}) where {T<:Number}
    A.n == 1 && return B
    mB, nB = size(B)
    nV = nnz(B)
    nzval = Vector{T}(undef, A.n * nV)
    rowval = Vector{Int}(undef, A.n * nV)
    colptr = Vector{Int}(undef, nB * A.n + 1)
    nzval = Vector{T}(undef, A.n * nV)
    colptr[1] = 1
    for i = 1:A.n
        r0 = (i - 1) * mB
        start = nV * (i - 1)
        @inbounds @simd for k = 1:nV
            rowval[start+k] = B.rowval[k] + r0
            nzval[start+k] = B.nzval[k]
        end
        colbase = (i - 1) * nB
        @inbounds @simd for j = 2:nB+1
            colptr[colbase+j] = B.colptr[j] + start
        end
    end
    SparseMatrixCSC(mB * A.n, nB * A.n, colptr, rowval, nzval)
end

function LinearAlgebra.kron(A::SparseMatrixCSC{T}, B::IMatrix) where {T<:Number}
    B.n == 1 && return A
    mA, nA = size(A)
    nV = nnz(A)
    rowval = Vector{Int}(undef, B.n * nV)
    colptr = Vector{Int}(undef, nA * B.n + 1)
    nzval = Vector{T}(undef, B.n * nV)
    z = 1
    colptr[1] = 1
    @inbounds for i = 1:nA
        rstart = A.colptr[i]
        rend = A.colptr[i+1] - 1
        colbase = (i - 1) * B.n + 1
        @inbounds for k = 1:B.n
            irow_Nb = k - B.n
            @inbounds @simd for r = rstart:rend
                rowval[z] = A.rowval[r] * B.n + irow_Nb
                nzval[z] = A.nzval[r]
                z += 1
            end
            colptr[colbase+k] = z
        end
    end
    SparseMatrixCSC(mA * B.n, nA * B.n, colptr, rowval, nzval)
end

function LinearAlgebra.kron(A::AbstractPermMatrix{T}, B::IMatrix) where {T<:Number}
    nA = size(A, 1)
    nB = size(B, 1)
    nB == 1 && return A
    vals = Vector{T}(undef, nB * nA)
    perm = Vector{Int}(undef, nB * nA)
    @inbounds for i = 1:nA
        start = (i - 1) * nB
        permAi = (A.perm[i] - 1) * nB
        val = A.vals[i]
        @inbounds @simd for j = 1:nB
            perm[start+j] = permAi + j
            vals[start+j] = val
        end
    end
    basetype(A)(perm, vals)
end

function LinearAlgebra.kron(A::IMatrix, B::AbstractPermMatrix{Tv,Ti}) where {Tv<:Number,Ti<:Integer}
    nA = size(A, 1)
    nB = size(B, 1)
    nA == 1 && return B
    perm = Vector{Int}(undef, nB * nA)
    vals = Vector{Tv}(undef, nB * nA)
    @inbounds for i = 1:nA
        start = (i - 1) * nB
        @inbounds @simd for j = 1:nB
            perm[start+j] = start + B.perm[j]
            vals[start+j] = B.vals[j]
        end
    end
    basetype(B)(perm, vals)
end

function LinearAlgebra.kron(A::StridedMatrix{Tv}, B::AbstractPermMatrix{Tb}) where {Tv<:Number,Tb<:Number}
    mA, nA = size(A)
    nB = size(B, 1)
    BC = PermMatrixCSC(B)
    perm, vals = BC.perm, BC.vals
    nzval = Vector{promote_type(Tv, Tb)}(undef, mA * nA * nB)
    rowval = Vector{Int}(undef, mA * nA * nB)
    colptr = collect(1:mA:nA*nB*mA+1)
    z = 1
    @inbounds for j = 1:nA
        @inbounds for j2 = 1:nB
            p2 = perm[j2]
            val2 = vals[j2]
            ir = p2
            @inbounds @simd for i = 1:mA
                nzval[z] = A[i, j] * val2  # merge
                rowval[z] = ir
                z += 1
                ir += nB
            end
        end
    end
    SparseMatrixCSC(mA * nB, nA * nB, colptr, rowval, nzval)
end

function LinearAlgebra.kron(A::AbstractPermMatrix{Ta}, B::StridedMatrix{Tb}) where {Tb<:Number,Ta<:Number}
    mB, nB = size(B)
    nA = size(A, 1)
    AC = PermMatrixCSC(A)
    perm, vals = AC.perm, AC.vals
    nzval = Vector{promote_type(Ta, Tb)}(undef, mB * nA * nB)
    rowval = Vector{Int}(undef, mB * nA * nB)
    colptr = collect(1:mB:nA*nB*mB+1)
    z = 0
    @inbounds for j = 1:nA
        p1 = perm[j]
        val2 = vals[j]
        ir = (p1 - 1) * mB
        for j2 = 1:nB
            @inbounds @simd for i2 = 1:mB
                nzval[z+i2] = B[i2, j2] * val2
                rowval[z+i2] = ir + i2
            end
            z += mB
        end
    end
    SparseMatrixCSC(nA * mB, nA * nB, colptr, rowval, nzval)
end

function LinearAlgebra.kron(A::AbstractPermMatrix{<:Number}, B::AbstractPermMatrix{<:Number})
    @assert basetype(A) == basetype(B)
    nA = size(A, 1)
    nB = size(B, 1)
    vals = kron(A.vals, B.vals)
    perm = Vector{Int}(undef, nB * nA)
    @inbounds for i = 1:nA
        start = (i - 1) * nB
        permAi = (A.perm[i] - 1) * nB
        @inbounds @simd for j = 1:nB
            perm[start+j] = permAi + B.perm[j]
        end
    end
    basetype(A)(perm, vals)
end

LinearAlgebra.kron(A::AbstractPermMatrix{<:Number}, B::Diagonal{<:Number}) = kron(A, basetype(A)(B))
LinearAlgebra.kron(A::Diagonal{<:Number}, B::AbstractPermMatrix{<:Number}) = kron(basetype(B)(A), B)

function LinearAlgebra.kron(A::AbstractPermMatrix{Ta}, B::SparseMatrixCSC{Tb}) where {Ta<:Number,Tb<:Number}
    nA = size(A, 1)
    mB, nB = size(B)
    nV = nnz(B)
    AC = PermMatrixCSC(A)
    perm, vals = AC.perm, AC.vals
    nzval = Vector{promote_type(Ta, Tb)}(undef, nA * nV)
    rowval = Vector{Int}(undef, nA * nV)
    colptr = Vector{Int}(undef, nA * nB + 1)
    colptr[1] = 1
    @inbounds @simd for i = 1:nA
        start_row = (i - 1) * nV
        start_ri = (perm[i] - 1) * mB
        v0 = vals[i]
        @inbounds @simd for j = 1:nV
            nzval[start_row+j] = B.nzval[j] * v0
            rowval[start_row+j] = B.rowval[j] + start_ri
        end
        start_col = (i - 1) * nB + 1
        start_ci = (i - 1) * nV
        @inbounds @simd for j = 1:nB
            colptr[start_col+j] = B.colptr[j+1] + start_ci
        end
    end
    SparseMatrixCSC(mB * nA, nB * nA, colptr, rowval, nzval)
end

function LinearAlgebra.kron(A::SparseMatrixCSC{T}, B::AbstractPermMatrix{Tb}) where {T<:Number,Tb<:Number}
    nB = size(B, 1)
    mA, nA = size(A)
    nV = nnz(A)
    BC = PermMatrixCSC(B)
    perm, vals = BC.perm, BC.vals
    rowval = Vector{Int}(undef, nB * nV)
    colptr = Vector{Int}(undef, nA * nB + 1)
    nzval = Vector{promote_type(T, Tb)}(undef, nB * nV)
    z = 1
    colptr[z] = 1
    @inbounds for i = 1:nA
        rstart = A.colptr[i]
        rend = A.colptr[i+1] - 1
        @inbounds for k = 1:nB
            irow = perm[k]
            bval = vals[k]
            irow_nB = irow - nB
            @inbounds @simd for r = rstart:rend
                rowval[z] = A.rowval[r] * nB + irow_nB
                nzval[z] = A.nzval[r] * bval
                z += 1
            end
            colptr[(i-1)*nB+k+1] = z
        end
    end
    SparseMatrixCSC(mA * nB, nA * nB, colptr, rowval, nzval)
end

using Compat
using BenchmarkTools
using LinearAlgebra
using SparseArrays
using LuxurySparse

n = 16
Id = IMatrix(1 << n)
V = randn(ComplexF64, 1 << n)
Dv = Diagonal(V)

Pm = pmrand(ComplexF64, 1 << n)
Sp = SparseMatrixCSC(Pm)

Ds = randn(ComplexF64, 1 << 10, 1 << 10)

mats = [Id, Sp, Pm, Dv]
for A in mats
    bg = BenchmarkGroup()
    for B in mats
        if !(A === B === Ds)
            println("============ $(typeof(A))-$(typeof(B)) =============")
            display(@benchmark $A * $B)
            println()
        end
    end
    display(run(bg, verbose = true))
end

using Test
using LinearAlgebra, SparseArrays, Random

using LuxurySparse, StaticArrays
import LuxurySparse: staticize
using StaticArrays: SVector, SMatrix


Random.seed!(2)

@testset "staticize" begin
    @test staticize(1) == 1
    # permmatrix
    m = pmrand(ComplexF64, 4)
    sm = m |> staticize
    @test sm isa SPermMatrix{4,ComplexF64}
    @test sm.perm isa SVector
    @test sm.vals isa SVector
    @test sm.perm == m.perm
    @test sm.vals == m.vals
    dm = sm |> dynamicize
    @test dm isa PermMatrix{ComplexF64}
    @test dm.perm isa Vector
    @test dm.vals isa Vector
    @test dm.perm == m.perm
    @test dm.vals == m.vals

   # permmatrixcsc
    m = pmcscrand(ComplexF64, 4)
    println(m)
    sm = m |> staticize
    @test sm isa SPermMatrixCSC{4,ComplexF64}
    @test sm.perm isa SVector
    @test sm.vals isa SVector
    @test sm.perm == m.perm
    @test sm.vals == m.vals
    dm = sm |> dynamicize
    @test dm isa PermMatrixCSC{ComplexF64}
    @test dm.perm isa Vector
    @test dm.vals isa Vector
    @test dm.perm == m.perm
    @test dm.vals == m.vals

    # csc
    m = sprand(ComplexF64, 4, 4, 0.5)
    sm = m |> staticize
    @test sm.colptr isa SVector
    @test sm.rowval isa SVector
    @test sm.nzval isa SVector
    @test sm.nzval == m.nzval
    @test sm.rowval == m.rowval
    @test sm.colptr == m.colptr

    dm = sm |> dynamicize
    @test dm.colptr isa Vector
    @test dm.rowval isa Vector
    @test dm.nzval isa Vector
    @test dm.nzval == m.nzval
    @test dm.rowval == m.rowval
    @test dm.colptr == m.colptr

    # diagonal
    m = Diagonal(randn(ComplexF64, 4))
    sm = m |> staticize
    @test sm.diag isa SVector
    @test sm.diag == m.diag
    dm = sm |> dynamicize
    @test dm.diag isa Vector
    @test dm.diag == m.diag

    # dense vector
    m = randn(ComplexF64, 4)
    sm = m |> staticize
    @test sm isa SVector
    @test sm == m
    dm = sm |> dynamicize
    @test dm isa Vector
    @test dm == m

    # dense matrix
    m = randn(ComplexF64, 4, 4)
    sm = m |> staticize
    @test sm isa SMatrix
    @test sm == m
    dm = sm |> dynamicize
    @test dm isa Matrix
    @test dm == m

    m = @SMatrix rand(2, 2)
    @test staticize(m) === m
    m = rand(2, 2)
    @test dynamicize(m) === m
end

@testset "one/zero preserve static containers" begin
    for m in (staticize(pmrand(ComplexF64, 4)), staticize(pmcscrand(ComplexF64, 4)))
        o = one(m)
        @test o.perm isa SVector
        @test o.vals isa SVector
        @test Matrix(o) == Matrix{ComplexF64}(I, 4, 4)

        z = zero(m)
        @test z.perm isa SVector
        @test z.vals isa SVector
        @test Matrix(z) == zeros(ComplexF64, 4, 4)
    end
end

struct IterNz{MT}
    A::MT
end

Base.length(nz::IterNz{<:AbstractMatrix}) = length(nz.A)
Base.length(nz::IterNz{<:AbstractSparseMatrix}) = SparseArrays.nnz(nz.A)
Base.length(nz::IterNz{<:Adjoint}) = length(IterNz(nz.A.parent))
Base.length(nz::IterNz{<:Transpose}) = length(IterNz(nz.A.parent))
Base.length(nz::IterNz{<:Diagonal}) = size(nz.A, 1)
Base.length(nz::IterNz{<:AbstractPermMatrix}) = size(nz.A, 1)
Base.length(nz::IterNz{<:IMatrix}) = size(nz.A, 1)
Base.eltype(nz::IterNz) = eltype(nz.A)

# Diagonal
function Base.iterate(it::IterNz{<:Diagonal})
    0 == length(it) && return nothing
    return (1, 1, @inbounds it.A.diag[1]), 1
end
function Base.iterate(it::IterNz{<:Diagonal}, state)
    state == length(it) && return nothing
    state += 1
    return (state, state, @inbounds it.A.diag[state]), state
end

# IMatrix
function Base.iterate(it::IterNz{<:IMatrix{T}}) where T
    0 == length(it) && return nothing
    return (1, 1, one(T)), 1
end
function Base.iterate(it::IterNz{<:IMatrix{T}}, state) where T
    state == length(it) && return nothing
    state += 1
    return (state, state, one(T)), state
end

# PermMatrix
function Base.iterate(it::IterNz{<:PermMatrix})
    0 == length(it) && return nothing
    return (1, (@inbounds it.A.perm[1]), (@inbounds it.A.vals[1])), 1
end
function Base.iterate(it::IterNz{<:PermMatrix}, state)
    state == length(it) && return nothing
    state += 1
    return (state, (@inbounds it.A.perm[state]), (@inbounds it.A.vals[state])), state
end

# PermMatrixCSC
function Base.iterate(it::IterNz{<:PermMatrixCSC})
    0 == length(it) && return nothing
    return ((@inbounds it.A.perm[1]), 1, (@inbounds it.A.vals[1])), 1
end
function Base.iterate(it::IterNz{<:PermMatrixCSC}, state)
    state == length(it) && return nothing
    state += 1
    return ((@inbounds it.A.perm[state]), state, (@inbounds it.A.vals[state])), state
end

# AbstractMatrix
function Base.iterate(it::IterNz{<:AbstractMatrix})
    0 == length(it) && return nothing
    return (1, 1, (@inbounds it.A[1])), (1, 1, 1)
end
function Base.iterate(it::IterNz{<:AbstractMatrix}, state)
    (i, j, k) = state
    k == length(it) && return nothing
    M = size(it.A, 1)
    if i == M
        i = 1
        j += 1
    else
        i += 1
    end
    k += 1
    return (i, j, (@inbounds it.A[k])), (i, j, k)
end

# SparseMatrixCSC
function Base.iterate(it::IterNz{<:SDSparseMatrixCSC})
    0 == length(it) && return nothing
    j = 1
    while j <= size(it.A, 2)
        it.A.colptr[j+1] > 1 && break
        j += 1
    end
    return (@inbounds(it.A.rowval[1]), j, @inbounds(it.A.nzval[1])), (j, 1)
end
function Base.iterate(it::IterNz{<:SDSparseMatrixCSC}, state)
    (j, k) = state
    k == length(it) && return nothing
    k += 1
    while j <= size(it.A, 2)
        it.A.colptr[j+1] > k && break
        j += 1
    end
    return (@inbounds(it.A.rowval[k]), j, @inbounds(it.A.nzval[k])), (j, k)
end

# Adjoint and Transpose
for (T, F) in [(:Adjoint, :conj), (:Transpose, :identity)]
    @eval function Base.iterate(it::IterNz{<:$T})
        res = iterate(IterNz(it.A.parent))
        res === nothing && return nothing
        (i, j, v), state = res
        (j, i, $F(v)), state
    end
    @eval function Base.iterate(it::IterNz{<:$T}, state)
        res = iterate(IterNz(it.A.parent), state)
        res === nothing && return nothing
        (i, j, v), state = res
        (j, i, $F(v)), state
    end
end

using Test, Random
using LuxurySparse
using SparseArrays
using LinearAlgebra

Random.seed!(2)

p1 = IMatrix(4)
sp = sprand(ComplexF64, 4, 4, 0.5)
ds = rand(ComplexF64, 4, 4)
pm = PermMatrix([2, 3, 4, 1], randn(4))
v = [0.5, 0.3im, 0.2, 1.0]
dv = Diagonal(v)

@testset "basic" begin
    @test p1 == copy(p1)
    @test eltype(p1) == Bool
    @test size(p1) == (4, 4)
    @test size(p1, 1) == size(p1, 2) == 4
    @test Matrix(p1) == [1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 1]

    p0 = similar(p1, ComplexF64)
    @test p0 !== p1
    p2 = copyto!(p1, p0)
    @test p2 == p0
    @test_throws DimensionMismatch copyto!(p0, IMatrix(2))
end

@testset "conversion" begin
    for mat in Any[p1, pm, dv]
        @test mat == SparseMatrixCSC(mat)
        @test mat == Matrix(mat)
    end
    for mat in Any[p1, pm, dv]
        @test mat == PermMatrix(mat)
    end
    @test Diagonal(p1) == p1

    @test SparseMatrixCSC(Diagonal(fill(2, 4))) ≈ Diagonal(fill(2, 4))
end

@testset "sparse" begin
    @show p1
    @test LuxurySparse.length(IterNz(p1)) == 4
end

@testset "linalg" begin
    for op in Any[conj, real, transpose, copy, inv]
        @test op(p1) == Matrix(I, 4, 4)
        @test typeof(op(p1)) == typeof(p1)
    end
    @test imag(p1) == zeros(4, 4)
    @test p1' == Matrix(I, 4, 4)
    @test ishermitian(p1)
end

@testset "elementary" begin
    @test all(isapprox.(conj(p1), conj(Matrix(p1))))
    @test all(isapprox.(real(p1), real(Matrix(p1))))
    @test all(isapprox.(imag(p1), imag(Matrix(p1))))
end

@testset "basicmath" begin
    @test p1 * 2im == Matrix(p1) * 2im
    @test p1 / 2.0 == Matrix(p1) / 2.0
end

@testset "one" begin
    @test one(IMatrix(4)) === IMatrix{Bool}(4)
    @test one(IMatrix{Float64}(4)) === IMatrix{Float64}(4)
    @test Matrix(one(IMatrix{Float64}(4))) == Matrix{Float64}(I, 4, 4)
end

@testset "push coverage" begin
    @test SparseMatrixCSC(IMatrix(3)) ≈ Diagonal(ones(3))
    @test Diagonal(IMatrix(3)) ≈ Diagonal(ones(3))
    @test IMatrix(Diagonal(ones(3))) === IMatrix{Float64}(3)
    @test IMatrix{ComplexF64}(Diagonal(ones(3))) === IMatrix{ComplexF64}(3)
    @test_throws DimensionMismatch IMatrix(ones(3, 5))
    @test_throws DimensionMismatch IMatrix{ComplexF64}(ones(3, 5))
    @test IMatrix(3) .* 2 == IMatrix(3) * 2 == Diagonal([2,2,2])
    @test 2 .* IMatrix(3) == 2 * IMatrix(3) == Diagonal([2,2,2])
    @test IMatrix(3) ≈ IMatrix{Float64}(3)
end

"""
    SparseMatrixCOO(is::Vector, js::Vector, vs::Vector, m::Int, n::Int) -> SparseMatrixCOO
    SparseMatrixCOO{Tv, Ti}(is::Vector{Ti}, js::Vector{Ti}, vs::Vector{Tv}, m::Int, n::Int) -> SparseMatrixCOO

A sparse matrix in COOrdinate format.

Values `vs` are added to the matrix at rows `is` and columns `js` in a matrix with `m` rows and `n` columns.

Also known as the ‘ijv’ or ‘triplet’ format.

# Notes

COO matrices should not be used in arithmetic operations like addition, subtraction, multiplication, division, and matrix power.

### Advantages of the COO format
* facilitates fast conversion among sparse formats
* permits duplicate entries (see example)
* very fast conversion to and from CSR/CSC formats (CSR is not implemented)

### Disadvantages of the COO format
does not directly support:
* arithmetic operations
* slicing

### Intended Usage
* COO is a fast format for constructing sparse matrices
* Once a matrix has been constructed, convert to CSR or CSC format for fast arithmetic and matrix vector operations
* By default when converting to CSR or CSC format, duplicate (i,j) entries will be summed together. This facilitates efficient construction of finite element matrices and the like. (see example)

# Example

```julia-repl
julia> SparseMatrixCOO([4,3,1,2,2], [2,3,1,4,4], [1,2,3,4,5], 4,4) # duplicate entries at (2,4) summed together
4×4 SparseMatrixCOO{Int64, Int64}:
 3  0  0  0
 0  0  0  9
 0  0  2  0
 0  1  0  0

```

"""
mutable struct SparseMatrixCOO{Tv,Ti} <: AbstractSparseMatrix{Tv,Ti}
    is::Vector{Ti}
    js::Vector{Ti}
    vs::Vector{Tv}
    m::Int
    n::Int

    function SparseMatrixCOO{Tv,Ti}(
        is::Vector{Ti},
        js::Vector{Ti},
        vs::Vector{Tv},
        m::Int,
        n::Int,
    ) where {Ti,Tv}
        length(is) == length(js) == length(vs) ||
            throw(ArgumentError("Input row, col, data should be equal size."))
        new{Tv,Ti}(is, js, vs, m, n)
    end
end

SparseMatrixCOO(is::Vector{Ti}, js::Vector{Ti}, vs::Vector{Tv}, m, n) where {Ti,Tv} =
    SparseMatrixCOO{Tv,Ti}(is, js, vs, m, n)

Base.copy(coo::SparseMatrixCOO{Tv,Ti}) where {Tv,Ti} =
    SparseMatrixCOO{Tv,Ti}(copy(coo.is), copy(coo.js), copy(coo.vs), coo.m, coo.n)
function Base.copyto!(A::SparseMatrixCOO{Tv,Ti}, B::SparseMatrixCOO{Tv,Ti}) where {Tv,Ti}
    size(A) == size(B) && nnz(A) == nnz(B) ||
        throw(MethodError("size/nnz of two coo matrices do not match!"))
    copyto!(A.is, B.is)
    copyto!(A.js, B.js)
    copyto!(A.vs, B.vs)
    A
end

function SparseMatrixCOO{Tv,Ti}(
    ::UndefInitializer,
    m::Int,
    n::Int,
    nnz::Int = 0,
) where {Tv,Ti<:Integer}
    is = Vector{Ti}(undef, nnz)
    js = Vector{Ti}(undef, nnz)
    vs = Vector{Tv}(undef, nnz)
    return SparseMatrixCOO(is, js, vs, m, n)
end

function SparseMatrixCOO{T}(::UndefInitializer, m::Int, n::Int, nnz::Int = 0) where {T}
    return SparseMatrixCOO{T,Int}(undef, m, n, nnz)
end

"""
    allocated_coo(::Type, M::Int, N::Int, nnz::Int) -> SparseMatrixCOO

Construct a preallocated [`SparseMatrixCOO`](@ref) instance that holds values of `::Type` with `M` rows, `N` columns, and `nnz` nonzero elements.
"""
function allocated_coo(::Type{T}, M::Int, N::Int, nnz::Int) where {T}
    SparseMatrixCOO{T}(undef, M, N, nnz)
end

function Base.getindex(coo::SparseMatrixCOO{Tv,Ti}, i::Integer, j::Integer) where {Tv,Ti}
    res = zero(Tv)
    for k = 1:nnz(coo)
        if coo.is[k] == i && coo.js[k] == j
            res += coo.vs[k]
        end
    end
    res
end

Base.size(coo::SparseMatrixCOO) = (coo.m, coo.n)
Base.size(coo::SparseMatrixCOO, axis::Int) =
    axis == 1 ? coo.m : (axis == 2 ? coo.n : throw(MethodError("invalid axis parameter")))

SparseArrays.nnz(coo::SparseMatrixCOO) = coo.is |> length
SparseArrays.nonzeros(coo::SparseMatrixCOO) = coo.vs

function SparseArrays.dropzeros!(coo::SparseMatrixCOO{Tv,Ti}; trim::Bool = false) where {Tv,Ti}
    mask = abs.(coo.vs) .> 1e-15
    SparseMatrixCOO{Tv,Ti}(coo.is[mask], coo.js[mask], coo.vs[mask], coo.m, coo.n)
end

SparseArrays.findnz(coo::SparseMatrixCOO) = (coo.is, coo.js, coo.vs)

Base.@propagate_inbounds function Base.setindex!(
    coo::SparseMatrixCOO{Tv,Ti},
    v,
    i::Integer,
    j::Integer,
) where {Tv,Ti}
    @boundscheck (1 <= i <= coo.m) && (1 <= j <= coo.n) || throw(BoundsError(coo, (i, j)))

    push!(coo.is, i)
    push!(coo.js, j)
    push!(coo.vs, convert(Tv, v))
    return coo
end

using Test
using LuxurySparse
using LinearAlgebra
using SparseArrays

@testset "broadcast *" begin

    @testset "Diagonal .* $(nameof(typeof(M)))" for M in [[pmrand(3)]..., pmcscrand(3)]
        M1 = Diagonal(rand(3))
        out = M1 .* M
        @test typeof(out) <: Diagonal
        @test out ≈ Matrix(M1) .* M

        out = M .* M1
        @test typeof(out) <: Diagonal
        @test out ≈ Matrix(M) .* M1
    end

    @testset "PermMatrix .* $(nameof(typeof(M)))" for M in Any[
        rand(3, 3),
        pmrand(3),
        sprand(3, 3, 0.5),
    ]
        M1 = pmrand(3)
        out = M1 .* M
        @test typeof(out) <: PermMatrix
        @test out ≈ Matrix(M1) .* M

        out = M .* M1
        @test typeof(out) <: PermMatrix
        @test out ≈ M .* Matrix(M1)

        M1 = pmcscrand(3)
        out = M1 .* M
        @test typeof(out) <: PermMatrixCSC
        @test out ≈ Matrix(M1) .* M

        out = M .* M1
        !(M isa PermMatrix) && @test typeof(out) <: PermMatrixCSC
        @test out ≈ M .* Matrix(M1)
    end

    @testset "IMatrix .* $(nameof(typeof(M)))" for M in Any[
        rand(3, 3),
        pmrand(3),
        pmcscrand(3),
        sprand(3, 3, 0.5),
    ]
        eye = IMatrix(3)
        out = eye .* M
        @test typeof(out) <: Diagonal
        @test out ≈ Matrix(eye) .* M

        out = M .* eye
        @test typeof(out) <: Diagonal
        @test out ≈ M .* Matrix(eye)
    end

    @test IMatrix(3) .* IMatrix(3) === IMatrix(3)
    d = Diagonal(rand(3))
    sp = sprand(3, 3, 0.5)
    @test d .* sp ≈ Matrix(d) .* Matrix(sp)
    @test_broken typeof(d .* sp) <: Diagonal

    @testset "Number .* $(nameof(typeof(M)))" for M in Any[pmrand(3), Diagonal(randn(3))]
        @test 3.0 .* M ≈ 3.0 .* Matrix(M) && M .* 3.0 ≈ Matrix(M) .* 3.0
        @test typeof(M .* 3.0) == typeof(M)
    end
end


@testset "broadcast -" begin

    @testset "Diagonal .- $(nameof(typeof(M)))" for M in Any[pmrand(3)]
        M1 = Diagonal(rand(3))
        @test M1 .- M ≈ Matrix(M1) .- M
        @test M .- M1 ≈ Matrix(M) .- M1
    end

    @testset "PermMatrix .* $(nameof(typeof(M)))" for M in Any[
        2.0,
        rand(3, 3),
        pmrand(3),
        sprand(3, 0.5),
        sprand(3, 3, 0.5),
    ]
        M1 = pmrand(3)
        @test M1 .- M ≈ Matrix(M1) .- M
        @test M .- M1 ≈ M .- Matrix(M1)

        M1 = pmcscrand(3)
        @test M1 .- M ≈ Matrix(M1) .- M
        @test M .- M1 ≈ M .- Matrix(M1)
    end

    @testset "IMatrix .* $(nameof(typeof(M)))" for M in Any[
        2.0,
        rand(3, 3),
        pmrand(3),
        sprand(3, 0.5),
        sprand(3, 3, 0.5),
    ]
        eye = IMatrix(3)
        @test eye .- M ≈ Matrix(eye) .- M

        @test M .- eye ≈ M .- Matrix(eye)
    end

    @test IMatrix(3) .- IMatrix(3) ≈ zeros(3, 3)
end

################## To IMatrix ######################
function IMatrix{T}(A::AbstractMatrix) where {T}
    IMatrix{T}(size(A, 1) == size(A, 2) ? size(A, 2) : throw(DimensionMismatch()))
end
function IMatrix(A::AbstractMatrix{T}) where {T}
    IMatrix{T}(size(A, 1) == size(A, 2) ? size(A, 2) : throw(DimensionMismatch()))
end

################## To Diagonal ######################
Diagonal(A::AbstractPermMatrix) = Diagonal(diag(A))
Diagonal(A::IMatrix{T}) where {T} = Diagonal{T}(ones(T, A.n))
Diagonal{T}(A::IMatrix) where {T} = Diagonal{T}(ones(T, A.n))

################## To SparseMatrixCSC ######################
SparseMatrixCSC{Tv,Ti}(A::IMatrix) where {Tv,Ti<:Integer} =
    SparseMatrixCSC{Tv,Ti}(I, A.n, A.n)
SparseMatrixCSC{Tv}(A::IMatrix) where {Tv} = SparseMatrixCSC{Tv,Int}(A)
SparseMatrixCSC(A::IMatrix{T}) where {T} = SparseMatrixCSC{T,Int}(I, A.n, A.n)
function SparseMatrixCSC(M::AbstractPermMatrix)
    n = size(M, 1)
    MC = PermMatrixCSC(M)
    SparseMatrixCSC(n, n, collect(1:n+1), MC.perm, MC.vals)
end

SparseMatrixCSC{Tv,Ti}(M::AbstractPermMatrix{Tv,Ti}) where {Tv,Ti} = SparseMatrixCSC(M)
SparseMatrixCSC(coo::SparseMatrixCOO) = sparse(coo.is, coo.js, coo.vs, coo.m, coo.n)

################## To Dense ######################
Matrix{T}(A::IMatrix) where {T} = Matrix{T}(I, A.n, A.n)
Matrix(A::IMatrix{T}) where {T} = Matrix{T}(I, A.n, A.n)

function Matrix{T}(X::PermMatrix) where {T}
    n = size(X, 1)
    Mf = zeros(T, n, n)
    @simd for i = 1:n
        @inbounds Mf[i, X.perm[i]] = X.vals[i]
    end
    return Mf
end
function Matrix{T}(X::PermMatrixCSC) where {T}
    n = size(X, 1)
    Mf = zeros(T, n, n)
    @simd for j = 1:n
        @inbounds Mf[X.perm[j], j] = X.vals[j]
    end
    return Mf
end
Matrix(X::AbstractPermMatrix{T}) where {T} = Matrix{T}(X)

function Matrix(coo::SparseMatrixCOO{T}) where {T}
    mat = zeros(T, coo.m, coo.n)
    for (i, j, v) in zip(coo.is, coo.js, coo.vs)
        mat[i, j] += v
    end
    mat
end

################## To PermMatrix ######################
function PermMatrix(pc::PermMatrixCSC)
    order = fast_invperm(pc.perm)
    PermMatrix(order, pc.vals[order])
end
function PermMatrixCSC(pc::PermMatrix)
    order = fast_invperm(pc.perm)
    PermMatrixCSC(order, pc.vals[order])
end
for MT in [:PermMatrix, :PermMatrixCSC]
    @eval $MT{Tv,Ti}(A::IMatrix) where {Tv,Ti} =
        $MT{Tv,Ti}(Vector{Ti}(1:A.n), ones(Tv, A.n))
    @eval $MT{Tv}(X::IMatrix) where {Tv} = $MT{Tv,Int}(X)
    @eval $MT(X::IMatrix{T}) where {T} = $MT{T,Int}(X)
    @eval $MT{Tv,Ti}(A::$MT) where {Tv,Ti} =
        $MT(Vector{Ti}(A.perm), Vector{Tv}(A.vals))
end

# NOTE: bad implementation!
function _findnz(A::AbstractMatrix)
    I = findall(!iszero, A)
    getindex.(I, 1), getindex.(I, 2), A[I]
end

_findnz(A::AbstractSparseArray) = findnz(A)

function PermMatrix{Tv,Ti}(A::AbstractMatrix) where {Tv,Ti}
    PermMatrix(PermMatrixCSC(A))
end
function PermMatrixCSC{Tv,Ti}(A::AbstractMatrix) where {Tv,Ti}
    i, j, v = _findnz(A)
    j == collect(1:size(A, 2)) || throw(ArgumentError("This is not a PermMatrix"))
    PermMatrixCSC{Tv,Ti}(Vector{Ti}(i), Vector{Tv}(v))
end

for MT in [:PermMatrix, :PermMatrixCSC]
    @eval $MT(A::AbstractMatrix{T}) where {T} = $MT{T,Int}(A)
    @eval $MT(A::SparseMatrixCSC{Tv,Ti}) where {Tv,Ti} = $MT{Tv,Ti}(A) # inherit indice type
    @eval $MT{Tv,Ti}(A::Diagonal{Tv}) where {Tv,Ti} = $MT(Vector{Ti}(1:size(A, 1)), A.diag)
    @eval function $MT{Tv,Ti,Vv,Vi}(
        A::AbstractMatrix,
    ) where {Tv,Ti<:Integer,Vv<:AbstractVector{Tv},Vi<:AbstractVector{Ti}}
        pm = $MT(PermMatrix{Tv,Ti}(A))
        PermMatrix(Vi(pm.perm), Vv(pm.vals))
    end
end
# lazy implementation

############## To SparseMatrixCOO ##############
function SparseMatrixCOO(A::Matrix{Tv}; atol = 1e-12) where {Tv}
    m, n = size(A)
    is = Int[]
    js = Int[]
    vs = Tv[]
    for j = 1:n
        for i = 1:m
            if abs(A[i, j]) > atol
                push!(is, i)
                push!(js, j)
                push!(vs, A[i, j])
            end
        end
    end
    SparseMatrixCOO(is, js, vs, m, n)
end

Base.convert(T::Type{<:AbstractPermMatrix}, m::AbstractMatrix) = m isa T ? m : T(m)
Base.convert(T::Type{<:IMatrix}, m::AbstractMatrix) = m isa T ? m : T(m)

using Documenter, LuxurySparse

# TODO: use Literate to process examples
# using Literate
# preprocess tutorial scripts

# make documents
makedocs(
    modules = [LuxurySparse],
    clean = false,
    format = :html,
    sitename = "LuxurySparse.jl",
    linkcheck = !("skiplinks" in ARGS),
    analytics = "UA-89508993-1",
    pages = [
        "Home" => "index.md",
        "Tutorial" => "tutorial.md",
        "Manual" => "luxurysparse.md",
    ],
    html_prettyurls = !("local" in ARGS),
    html_canonical = "https://quantumbfs.github.io/LuxurySparse.jl/latest/",
)

deploydocs(
    repo = "github.com/QuantumBFS/LuxurySparse.jl.git",
    target = "build",
    julia = "1.0",
    deps = nothing,
    make = nothing,
)

# SparseMatrixCSC
#Base.promote_rule(::Type{SparseMatrixCSC{Tv,Ti}}, ::Type{Matrix{T}}) where {Tv,Ti,T} =
#    Matrix{promote_type(T, Tv)}

# IMatrix
for MT in [:PermMatrix, :PermMatrixCSC]
    @eval Base.promote_rule(
        ::Type{IMatrix{T}},
        ::Type{$MT{Tv,Ti,Vv,Vi}},
    ) where {T,Tv,Ti,Vv,Vi} = (TT = promote_type(T, Tv); $MT{TT,Ti,Vector{TT},Vi})
end
Base.promote_rule(::Type{IMatrix{T}}, ::Type{SparseMatrixCSC{Tv,Ti}}) where {T,Tv,Ti} =
    SparseMatrixCSC{promote_type(T, Tv),Ti}
Base.promote_rule(::Type{IMatrix{TA}}, ::Type{Matrix{TB}}) where {TA,TB} = Array{TB,2}

# PermMatrix
Base.promote_rule(
    ::Type{<:AbstractPermMatrix{TvA,TiA}},
    ::Type{SparseMatrixCSC{TvB,TiB}},
) where {TvA,TiA,TvB,TiB} = SparseMatrixCSC{promote_type(TvA, TvB),promote_type(TiA, TiB)}
Base.promote_rule(::Type{<:AbstractPermMatrix{Tv,Ti}}, ::Type{Matrix{T}}) where {Tv,Ti,T} =
    Array{promote_type(Tv, T),2}

# patches
LinearAlgebra.fzero(S::IMatrix) = zero(eltype(S))

Broadcast.BroadcastStyle(::Type{<:IMatrix}) = StructuredMatrixStyle{Diagonal}()

# specialize identity
Broadcast.broadcasted(
    ::AbstractArrayStyle{2},
    ::typeof(*),
    a::IMatrix{T},
    b::IMatrix,
) where {T} = IMatrix{T}(a.n)
Broadcast.broadcasted(
    ::AbstractArrayStyle{2},
    ::typeof(*),
    a::IMatrix,
    b::AbstractVecOrMat,
) = Diagonal(b)
Broadcast.broadcasted(
    ::AbstractArrayStyle{2},
    ::typeof(*),
    a::AbstractVecOrMat,
    b::IMatrix,
) = Diagonal(a)

Broadcast.broadcasted(
    ::AbstractArrayStyle{2},
    ::typeof(*),
    a::IMatrix,
    b::Number,
) = Diagonal(fill(b, a.n))
Broadcast.broadcasted(
    ::AbstractArrayStyle{2},
    ::typeof(*),
    a::Number,
    b::IMatrix,
) = Diagonal(fill(a, b.n))

# specialize perm matrix
function _broadcast_perm_prod(A::AbstractPermMatrix, B::AbstractMatrix)
    dest = similar(A, Base.promote_op(*, eltype(A), eltype(B)))
    @inbounds for (i, j, a) in IterNz(A)
        dest[i, j] = a * B[i, j]
    end
    return dest
end

Broadcast.broadcasted(
    ::AbstractArrayStyle{2},
    ::typeof(*),
    A::AbstractPermMatrix,
    B::AbstractMatrix,
) = _broadcast_perm_prod(A, B)
Broadcast.broadcasted(
    ::AbstractArrayStyle{2},
    ::typeof(*),
    A::AbstractMatrix,
    B::AbstractPermMatrix,
) = _broadcast_perm_prod(B, A)
Broadcast.broadcasted(::AbstractArrayStyle{2}, ::typeof(*), A::AbstractPermMatrix, B::AbstractPermMatrix) =
    _broadcast_perm_prod(A, B)

Broadcast.broadcasted(::AbstractArrayStyle{2}, ::typeof(*), A::AbstractPermMatrix, B::IMatrix) =
    Diagonal(A)
Broadcast.broadcasted(::AbstractArrayStyle{2}, ::typeof(*), A::IMatrix, B::AbstractPermMatrix) =
    Diagonal(B)

function _broadcast_diag_perm_prod(A::Diagonal, B::AbstractPermMatrix)
    Diagonal(A.diag .* getindex.(Ref(B), 1:size(A, 1), 1:size(A, 2)))
end

Broadcast.broadcasted(::AbstractArrayStyle{2}, ::typeof(*), A::AbstractPermMatrix, B::Diagonal) =
    _broadcast_diag_perm_prod(B, A)
Broadcast.broadcasted(::AbstractArrayStyle{2}, ::typeof(*), A::Diagonal, B::AbstractPermMatrix) =
    _broadcast_diag_perm_prod(A, B)

# TODO: commit this upstream
# specialize Diagonal .* SparseMatrixCSC
# Broadcast.broadcasted(
#     ::AbstractArrayStyle{2},
#     ::typeof(*),
#     A::Diagonal,
#     B::SparseMatrixCSC,
# ) = Broadcast.broadcasted(*, A, Diagonal(B))

# Broadcast.broadcasted(
#     ::AbstractArrayStyle{2},
#     ::typeof(*),
#     A::SparseMatrixCSC,
#     B::Diagonal,
# ) = Broadcast.broadcasted(*, Diagonal(A), B)

Broadcast.broadcasted(
    ::AbstractArrayStyle{2},
    ::typeof(*),
    a::AbstractPermMatrix,
    b::Number,
) = basetype(a)(a.perm, a.vals .* b)

Broadcast.broadcasted(
    ::AbstractArrayStyle{2},
    ::typeof(*),
    a::Number,
    b::AbstractPermMatrix,
) = basetype(b)(b.perm, a .* b.vals)

using BenchmarkTools
using Yao
using Yao.Intrinsics
using Yao.Boost

v = randn(ComplexF64, 1 << 16)
bench = BenchmarkGroup()
xg = xgate(16, 2)
#bg["indices_with"] = @benchmarkable indices_with(2, bss)
bg = bench["Basic Gate"] = BenchmarkGroup()
bg["X"] = @benchmarkable xgate(16, 2)
bg["Y"] = @benchmarkable ygate(16, 2)
bg["Z"] = @benchmarkable zgate(16, 2)
bg["X*v"] = @benchmarkable $xg * v

############# controlled gates ##################
bg = bench["CZ Gate"] = BenchmarkGroup()
bg["CZ"] = @benchmarkable czgate(ComplexF64, 16, 3, 7)
bg["Diag-CZ"] = @benchmarkable controlled_U1(16, PAULI_Z, [3], 7)
bg["General-CZ"] = @benchmarkable general_controlled_gates(16, [P1], [7], [PAULI_Z], [3])

bg = bench["CX Gate"] = BenchmarkGroup()
bg["CNOT"] = @benchmarkable cxgate(ComplexF64, 16, 7, 3)
bg["PM-CNOT"] = @benchmarkable controlled_U1(16, PAULI_X, [3], 7)
bg["General-CNOT"] = @benchmarkable general_controlled_gates(16, [P1], [7], [PAULI_X], [3])

bg = bench["CY Gate"] = BenchmarkGroup()
bg["CY"] = @benchmarkable cygate(ComplexF64, 16, 7, 3)
bg["PM-CY"] = @benchmarkable controlled_U1(16, PAULI_Y, [3], 7)
bg["General-CY"] = @benchmarkable general_controlled_gates(16, [P1], [7], [PAULI_Y], [3])

##### TOFFOLI gate
bg = bench["Toffoli Gate"] = BenchmarkGroup()
bg["Toffoli"] = @benchmarkable toffoligate(16, 2, 3, 1)
bg["General-Toffoli"] =
    @benchmarkable general_controlled_gates(16, [P1, P1], [2, 3], [PAULI_X], [1])

showall(run(bench, verbose = true))

using Test, Random, SparseArrays, LinearAlgebra
import LuxurySparse: IMatrix, PermMatrix, PermMatrixCSC, basetype, AbstractPermMatrix, fastkron

@testset "kron" begin
    Random.seed!(2)

    p1 = IMatrix(4)
    sp = sprand(ComplexF64, 4, 4, 0.5)
    ds = rand(ComplexF64, 4, 4)
    pm = PermMatrix([2, 3, 4, 1], randn(4))
    pmc = PermMatrixCSC([2, 3, 4, 1], randn(4))
    v = [0.5, 0.3im, 0.2, 1.0]
    dv = Diagonal(v)

    for source in Any[p1, sp, ds, dv, pm, pmc],
            target in Any[p1, sp, ds, dv, pm, pmc]
        if source isa AbstractPermMatrix && target isa AbstractPermMatrix && basetype(source) != basetype(target)
            continue
        end
        lres = fastkron(source, target)
        rres = fastkron(target, source)
        flres = fastkron(Matrix(source), Matrix(target))
        frres = fastkron(Matrix(target), Matrix(source))
        @test lres == flres
        @test rres == frres
        @test eltype(lres) == eltype(flres)
        @test eltype(rres) == eltype(frres)
        if !(target === ds && source === ds)
            @test !(typeof(lres) <: StridedMatrix)
            @test !(typeof(rres) <: StridedMatrix)
        end
    end
end

module LuxurySparse

using LinearAlgebra, SparseArrays, Random
using StaticArrays: SVector, SMatrix, SDiagonal, SArray
import SparseArrays: SparseMatrixCSC
using SparseArrays.HigherOrderFns
import Base: Matrix
using Base: @propagate_inbounds
using LinearAlgebra
import LinearAlgebra: Diagonal
using LinearAlgebra: StructuredMatrixStyle
using Base.Broadcast:
    BroadcastStyle, AbstractArrayStyle, Broadcasted, DefaultArrayStyle, materialize!

# static types
export SDPermMatrix, SPermMatrix, PermMatrix, pmrand,
    SDPermMatrixCSC, SPermMatrixCSC, PermMatrixCSC, pmcscrand,
    SDSparseMatrixCSC, SSparseMatrixCSC, SparseMatrixCSC, sprand,
    SparseMatrixCOO,
    SDMatrix, SDVector,
    SDDiagonal, Diagonal,
    IMatrix,
    staticize, dynamicize,
    fast_invperm, fastkron,
    IterNz

include("utils.jl")
include("IMatrix.jl")
include("PermMatrix.jl")
include("SparseMatrixCOO.jl")
include("SSparseMatrixCSC.jl")

include("conversions.jl")
include("promotions.jl")
include("staticize.jl")
include("arraymath.jl")
include("linalg.jl")
include("kronecker.jl")
include("broadcast.jl")

include("iterate.jl")

end

using Test, SparseArrays
import LuxurySparse: SparseMatrixCOO, allocated_coo

coo1 = SparseMatrixCOO(
    [1, 4, 2, 3, 3, 3],
    [1, 1, 2, 4, 3, 4],
    [0.1, 0.2, 0.4im, 0.5, 0.3, 0.5im],
    4,
    4,
)

@testset "basic" begin
    @test eltype(coo1) == ComplexF64
    @test size(coo1, 1) == size(coo1, 2) == 4

    coo2 = allocated_coo(ComplexF64, 4, 4, 6)
    @test eltype(coo2) == ComplexF64
    @test nnz(coo2) == 6
    @test size(coo2) == (4, 4)
    @test size(coo2, 1) == size(coo2, 2) == 4

    @test coo1 == copy(coo1)
    @test coo1 == copyto!(coo2, coo1)

    @test Matrix(coo1) == [0.1 0 0 0; 0 0.4im 0 0; 0 0 0.3 0.5+0.5im; 0.2 0 0 0]
    @test sparse(coo1) == sparse(LuxurySparse.findnz(coo1)...)

    A = sprand(50, 50, 0.2) |> Matrix
    @test SparseMatrixCOO(A) == A
end

@testset "sparse" begin
    p1 = copy(coo1)
    @test LuxurySparse.nonzeros(p1) == p1.vs
    p1.vs[2] = 0
    @test LuxurySparse.dropzeros!(p1) ==
          [0.1 0 0 0; 0 0.4im 0 0; 0 0 0.3 0.5+0.5im; 0 0 0 0]
end

@testset "basicmath" begin
    @test coo1 * 2 == Matrix(coo1) * 2
    @test 2 * coo1 == 2 * Matrix(coo1)
    @test coo1 / 2 == Matrix(coo1) / 2
    @test coo1 * 2 isa SparseMatrixCOO
    @test coo1 / 2 isa SparseMatrixCOO
    @test 2 * coo1 isa SparseMatrixCOO
end

@testset "setindex" begin
    coo1[1, 1] = 0.2
    @test coo1.is[end] == 1
    @test coo1.js[end] == 1
    @test coo1.vs[end] == 0.2

    S = SparseMatrixCOO{Float32,Cint}(Cint[], Cint[], Float32[], 5, 5)
    S[1, 1] = 3
    @test S[1, 1] == 3
end

using Test, LuxurySparse

@testset "basic" begin
    m = sprand(ComplexF64, 4, 4, 0.5)
    sm = m |> staticize
    @test Matrix(m) == Matrix(sm)
    allsame = true
    for i=1:4, j=1:4
        allsame &= m[i,j] == sm[i,j]
    end
    @test allsame
    @test LuxurySparse.nnz(sm) == LuxurySparse.nnz(m)
    @test LuxurySparse.nonzeros(sm) == LuxurySparse.nonzeros(m)
    @test issparse(sm)
    @test LuxurySparse.dropzeros!(sm) == sm
    @test sm == m
    @test print(sm) === nothing
    @test display(sm) === nothing
end

####### linear algebra  ######
Base.inv(M::IMatrix) = M
LinearAlgebra.det(M::IMatrix) = 1
LinearAlgebra.diag(M::IMatrix{T}) where {T} = ones(T, M.n)
LinearAlgebra.logdet(M::IMatrix) = 0
Base.sqrt(x::AbstractPermMatrix) = sqrt(Matrix(x))
Base.sqrt(x::IMatrix) = x
Base.exp(x::AbstractPermMatrix) = exp(Matrix(x))
Base.exp(x::IMatrix) = ℯ * x

function Base.inv(M::AbstractPermMatrix)
    new_perm = fast_invperm(M.perm)
    return basetype(M)(new_perm, 1.0 ./ M.vals[new_perm])
end

####### multiply ###########
Base.:*(A::IMatrix, B::AbstractVector) =
    size(A, 2) == size(B, 1) ? B :
    throw(
        DimensionMismatch(
            "matrix A has dimensions $(size(A)), matrix B has dimensions $((size(B, 1), 1))",
        ),
    )

for MATTYPE in
    [:AbstractMatrix, :StridedMatrix, :Diagonal, :SparseMatrixCSC, :Matrix, :AbstractPermMatrix]
    @eval Base.:*(A::IMatrix, B::$MATTYPE) =
        A.n == size(B, 1) ? B :
        throw(
            DimensionMismatch(
                "matrix A has dimensions $(size(A)), matrix B has dimensions $(size(B))",
            ),
        )

    @eval Base.:*(A::$MATTYPE, B::IMatrix) =
        size(A, 2) == B.n ? A :
        throw(
            DimensionMismatch(
                "matrix A has dimensions $(size(A)), matrix B has dimensions $(size(B))",
            ),
        )
end

Base.:*(A::Adjoint{T,<:AbstractVector{T}}, B::IMatrix) where {T} =
    size(A, 2) == size(B, 1) ? A :
    throw(
        DimensionMismatch(
            "matrix A has dimensions $(size(A)), matrix B has dimensions $(size(B))",
        ),
    )

Base.:*(A::IMatrix, B::IMatrix) =
    size(A, 2) == size(B, 1) ? A :
    throw(
        DimensionMismatch(
            "matrix A has dimensions $(size(A)), matrix B has dimensions $(size(B))",
        ),
    )


########## Multiplication #############

function LinearAlgebra.mul!(Y::AbstractVector, A::AbstractPermMatrix, X::AbstractVector, alpha::Number, beta::Number)
    length(X) == size(A, 2) || throw(DimensionMismatch("input X length does not match permutation matrix A"))
    length(Y) == size(A, 2) || throw(DimensionMismatch("output Y length does not match permutation matrix A"))

    @inbounds for (i, j, p) in IterNz(A)
        Y[i] = p * X[j] * alpha + beta * Y[i]
    end
    return Y
end

# to diagonal
function Base.:*(D::Diagonal{Td}, A::PermMatrix{Ta}) where {Td,Ta}
    PermMatrix(A.perm, A.vals .* D.diag)
end
function Base.:*(D::Diagonal{Td}, A::PermMatrixCSC{Ta}) where {Td,Ta}
    PermMatrixCSC(A.perm, view(D.diag, A.perm) .* A.vals)
end
function Base.:*(A::PermMatrix{Ta}, D::Diagonal{Td}) where {Td,Ta}
    PermMatrix(A.perm, A.vals .* view(D.diag, A.perm))
end
function Base.:*(A::PermMatrixCSC{Ta}, D::Diagonal{Td}) where {Td,Ta}
    PermMatrixCSC(A.perm, A.vals .* D.diag)
end

# to self
function Base.:*(A::PermMatrix, B::PermMatrix)
    @assert basetype(A) == basetype(B)
    size(A, 1) == size(B, 1) || throw(DimensionMismatch())
    basetype(A)(B.perm[A.perm], A.vals .* view(B.vals, A.perm))
end

function Base.:*(A::PermMatrixCSC, B::PermMatrixCSC)
    @assert basetype(A) == basetype(B)
    size(A, 1) == size(B, 1) || throw(DimensionMismatch())
    basetype(A)(A.perm[B.perm], B.vals .* view(A.vals, B.perm))
end

# to matrix
function LinearAlgebra.mul!(C::AbstractMatrix, A::AbstractPermMatrix, X::AbstractMatrix, alpha::Number, beta::Number)
    size(X, 1) == size(A, 2) || throw(DimensionMismatch())
    AR = PermMatrix(A)
    C .= C .* beta .+ AR.vals .* view(X, AR.perm, :) .* alpha
end
function LinearAlgebra.mul!(C::AbstractMatrix, X::AbstractMatrix, A::AbstractPermMatrix, alpha::Number, beta::Number)
    size(X, 2) == size(A, 1) || throw(DimensionMismatch())
    AC = PermMatrixCSC(A)
    C .= C .* beta .+ reshape(AC.vals, 1, :) .* view(X, :, AC.perm) .* alpha
end
function LinearAlgebra.mul!(C::AbstractMatrix, A::AbstractPermMatrix, B::AbstractPermMatrix, alpha::Number, beta::Number)
    size(C, 1) == size(C, 2) == size(A, 1) == size(B, 1) || throw(DimensionMismatch())
    res = A * B
    for (i, j, v) in IterNz(res)
        C[i, j] = v * alpha + beta * C[i, j]
    end
    return C
end

# NOTE: this is just a temperory fix for v0.7. We should overload mul! in
# the future (when we start to drop v0.6) to enable buildin lazy evaluation.

Base.:*(x::Adjoint{<:Any,<:AbstractVector}, D::AbstractPermMatrix) = Matrix(x) * D
Base.:*(x::Transpose{<:Any,<:AbstractVector}, D::AbstractPermMatrix) = Matrix(x) * D
Base.:*(A::Adjoint{<:Any,<:AbstractArray}, D::AbstractPermMatrix) = Adjoint(adjoint(D) * parent(A))
Base.:*(A::Transpose{<:Any,<:AbstractArray}, D::AbstractPermMatrix) = Transpose(transpose(D) * parent(A))
Base.:*(A::Adjoint{<:Any,<:AbstractPermMatrix}, D::AbstractPermMatrix) = adjoint(parent(A)) * D
Base.:*(A::Transpose{<:Any,<:AbstractPermMatrix}, D::AbstractPermMatrix) = transpose(parent(A)) * D
Base.:*(A::AbstractPermMatrix, D::Adjoint{<:Any,<:AbstractPermMatrix}) = A * adjoint(parent(D))
Base.:*(A::AbstractPermMatrix, D::Transpose{<:Any,<:AbstractPermMatrix}) = A * transpose(parent(D))

############### Transpose, Adjoint for IMatrix ###############
for MAT in
    [:AbstractArray, :AbstractVector, :Matrix, :SparseMatrixCSC, :AbstractPermMatrix, :IMatrix]
    @eval Base.:*(A::Adjoint{<:Any,<:$MAT}, D::IMatrix) = Adjoint(D * parent(A))
    @eval Base.:*(A::Transpose{<:Any,<:$MAT}, D::IMatrix) = Transpose(D * parent(A))
    if MAT != :AbstactVector
        @eval Base.:*(A::IMatrix, D::Transpose{<:Any,<:$MAT}) = Transpose(parent(D) * A)
        @eval Base.:*(A::IMatrix, D::Adjoint{<:Any,<:$MAT}) = Adjoint(parent(D) * A)
    end
end

# to sparse
function Base.:*(A::AbstractPermMatrix, X::SparseMatrixCSC)
    nA = size(A, 1)
    mX, nX = size(X)
    mX == nA || throw(DimensionMismatch())
    AC = PermMatrixCSC(A)
    perm, vals = AC.perm, AC.vals
    nzval = similar(X.nzval)
    rowval = similar(X.rowval)
    @inbounds for j = 1:nX
        @inbounds for k = X.colptr[j]:X.colptr[j+1]-1
            r = perm[X.rowval[k]]
            nzval[k] = X.nzval[k] * vals[X.rowval[k]]
            rowval[k] = r
        end
    end
    sp = SparseMatrixCSC(mX, nX, X.colptr, rowval, nzval)
    SparseMatrixCSC(sp')'
end

function Base.:*(X::SparseMatrixCSC, A::AbstractPermMatrix)
    nA = size(A, 1)
    mX, nX = size(X)
    nX == nA || throw(DimensionMismatch())
    AC = PermMatrixCSC(A)
    perm, vals = AC.perm, AC.vals
    nzval = similar(X.nzval)
    colptr = similar(X.colptr)
    rowval = similar(X.rowval)
    colptr[1] = 1
    z = 1
    @inbounds for j = 1:nA
        pk = perm[j]
        va = vals[j]
        @inbounds @simd for k = X.colptr[pk]:X.colptr[pk+1]-1
            nzval[z] = X.nzval[k] * va
            rowval[z] = X.rowval[k]
            z += 1
        end
        colptr[j+1] = z
    end
    SparseMatrixCSC(mX, nX, colptr, rowval, nzval)
end

LinearAlgebra.rmul!(A::SparseMatrixCOO, B::Int) = (A.vs *= B; A)
LinearAlgebra.lmul!(B::Int, A::SparseMatrixCOO) = (A.vs *= B; A)
LinearAlgebra.rdiv!(A::SparseMatrixCOO, B::Int) = (A.vs /= B; A)

Base.:*(A::SparseMatrixCOO, B::Int) = rmul!(copy(A), B)
Base.:*(B::Int, A::SparseMatrixCOO) = lmul!(B, copy(A))
Base.:/(A::SparseMatrixCOO, B::Int) = rdiv!(copy(A), B)

Base.:-(ii::IMatrix) = (-1) * ii
Base.:-(pm::AbstractPermMatrix) = (-1) * pm

randomize!(m::AbstractArray) = randn!(m)
function randomize!(m::Diagonal)
    randomize!(m.diag)
    return m
end

function randomize!(m::SparseMatrixCSC)
    randomize!(m.nzval)
    return m
end

function randomize!(m::AbstractPermMatrix)
    randomize!(m.vals)
    return m
end

using Test
using Aqua
using LuxurySparse

@testset "Aqua" begin
    Aqua.test_all(LuxurySparse)
end

@testset "IMatrix" begin
    include("IMatrix.jl")
end

@testset "PermMatrix" begin
    include("PermMatrix.jl")
    include("PermMatrixCSC.jl")
end

@testset "SparseMatrixCOO" begin
    include("SparseMatrixCOO.jl")
end

@testset "SSparseMatrixCSC" begin
    include("SSparseMatrixCSC.jl")
end

@testset "kronecker" begin
    include("kronecker.jl")
end

@testset "linalg" begin
    include("linalg.jl")
end

@testset "staticize" begin
    include("staticize.jl")
end

@testset "broadcast" begin
    include("broadcast.jl")
end

@testset "iterate" begin
    include("iterate.jl")
end

using BenchmarkTools
using LuxurySparse
using LinearAlgebra
using SparseArrays

id = IMatrix(1 << 8)
v = randn(1 << 8) + im * randn(1 << 8)
Dv = Diagonal(v)

#sp = sprand(ComplexF64, 1<<8, 1<<8, 0.03)
#pm = PermuteMultiply(randperm(1<<8), randn(1<<8))
sp = SparseMatrixCSC(Dv)
ds = rand(ComplexF64, 1 << 4, 1 << 4)
pm = PermMatrix(Dv)

mats = [id, sp, ds, pm, Dv]
for A in mats
    bg = BenchmarkGroup()
    for B in mats
        if !(A === B === ds)
            println("============ $(typeof(A))-$(typeof(B)) =============")
            display(@benchmark kron($A, $B))
            println()
        end
    end
    display(run(bg, verbose = true))
end

using Test, LuxurySparse, SparseArrays, LinearAlgebra

@testset "iterate" begin
    for M in Any[
        pmrand(10),
        pmcscrand(10),
        Diagonal(randn(10)),
        IMatrix(10),
        randn(10, 10),
        sprand(10, 10, 0.5), 
    ]
        for A in Any[M, M', transpose(M)]
            O = zeros(eltype(A), size(A)...)
            it = IterNz(A)
            @test eltype(it) == eltype(A)
            for (i, j, v) in it
                O[i,j] = v
            end
            @test O ≈ A
        end
    end
    # static
    a = sparse([1,2,3], [3,4,4], randn(3), 4, 4)
    A = LuxurySparse.staticize(a)
    O = zeros(eltype(A), size(A)...)
    for (i, j, v) in IterNz(A)
        O[i,j] = v
    end
    @test O ≈ a
end

"""
    SSparseMatrixCSC{Tv,Ti<:Integer, NNZ, NP} <: AbstractSparseMatrix{Tv,Ti}

static version of SparseMatrixCSC
"""
struct SSparseMatrixCSC{Tv,Ti<:Integer,NNZ,NP} <:
        SparseArrays.AbstractSparseMatrixCSC{Tv,Ti}
    m::Int                  # Number of rows
    n::Int                  # Number of columns
    colptr::SVector{NP,Ti}      # Column i is in colptr[i]:(colptr[i+1]-1)
    rowval::SVector{NNZ,Ti}      # Row values of nonzeros
    nzval::SVector{NNZ,Tv}       # Nonzero values

    function SSparseMatrixCSC{Tv,Ti,NNZ,NP}(
        m::Integer,
        n::Integer,
        colptr::SVector{NP,Ti},
        rowval::SVector{NNZ,Ti},
        nzval::SVector{NNZ,Tv},
    ) where {Tv,Ti<:Integer,NNZ,NP}
        m < 0 && throw(ArgumentError("number of rows (m) must be ≥ 0, got $m"))
        n < 0 && throw(ArgumentError("number of columns (n) must be ≥ 0, got $n"))
        new(Int(m), Int(n), colptr, rowval, nzval)
    end
end
SparseArrays.getcolptr(M::SSparseMatrixCSC) = M.colptr
SparseArrays.rowvals(M::SSparseMatrixCSC) = M.rowval

function SSparseMatrixCSC(
    m::Integer,
    n::Integer,
    colptr::SVector,
    rowval::SVector,
    nzval::SVector,
)
    Tv = eltype(nzval)
    Ti = promote_type(eltype(colptr), eltype(rowval))
    SSparseMatrixCSC{Tv,Ti,length(nzval),n + 1}(m, n, colptr, rowval, nzval)
end

function Base.size(spm::SSparseMatrixCSC{Tv,Ti,NNZ,NP}, i::Integer) where {Tv,Ti,NNZ,NP}
    i == 1 ? spm.m : (i == 2 ? NP - 1 : throw(ArgumentError("dimension out of bound!")))
end
Base.size(spm::SSparseMatrixCSC{Tv,Ti,NNZ,NP}) where {Tv,Ti,NNZ,NP} = (spm.m, NP - 1)

function Base.getindex(ssp::SSparseMatrixCSC{Tv}, i::Integer, j::Integer) where {Tv}
    S = ssp.colptr[j]
    E = ssp.colptr[j+1] - 1
    for ii = S:E
        if i == ssp.rowval[ii]
            return ssp.nzval[ii]
        end
    end
    return Tv(0)
end

SparseArrays.issparse(::SSparseMatrixCSC) = true
SparseArrays.nonzeros(M::SSparseMatrixCSC) = M.nzval
SparseArrays.nnz(spm::SSparseMatrixCSC{Tv,Ti,NNZ}) where {Tv,Ti,NNZ} = NNZ
function SparseArrays.findnz(S::SSparseMatrixCSC{Tv,Ti}) where {Tv,Ti}
    numnz = nnz(S)
    I = Vector{Ti}(undef, numnz)
    J = Vector{Ti}(undef, numnz)
    V = Vector{Tv}(undef, numnz)

    count = 1
    @inbounds for col = 1:S.n, k = S.colptr[col]:(S.colptr[col+1]-1)
        I[count] = S.rowval[k]
        J[count] = col
        V[count] = S.nzval[k]
        count += 1
    end

    return (I, J, V)
end
SparseArrays.dropzeros!(M::SSparseMatrixCSC; trim::Bool = false) = M
SparseArrays.SparseMatrixCSC(sm::SSparseMatrixCSC) = dynamicize(sm)
Base.Matrix(sm::SSparseMatrixCSC) = Matrix(SparseMatrixCSC(sm))

@static if isdefined(SparseArrays, :_checkbuffers)
    # fix issue #73 - show fail
    SparseArrays._checkbuffers(S::SSparseMatrixCSC) = (@assert SparseArrays._goodbuffers(S); S)
    SparseArrays._goodbuffers(S::SSparseMatrixCSC) = SparseArrays._goodbuffers(size(S)..., SparseArrays.getcolptr(S), SparseArrays.getrowval(S), SparseArrays.nonzeros(S))
end

function fast_invperm(order)
    v = similar(order)
    @inbounds @simd for i = 1:length(order)
        v[order[i]] = i
    end
    v
end

findnz(M::Diagonal) = (collect(1:size(M, 1)), collect(1:size(M, 1)), M.diag)
nnz(M::Diagonal) = length(M.diag)

using Test, Random
import LuxurySparse: PermMatrix, pmrand
import LuxurySparse
using SparseArrays: sprand, SparseMatrixCSC
using LinearAlgebra

Random.seed!(2)
p1 = PermMatrix([1, 4, 2, 3], [0.1, 0.2, 0.4im, 0.5])
p2 = PermMatrix([2, 1, 4, 3], [0.1, 0.2, 0.4, 0.5])
#p3 = PermMatrix([4,1,2,3],[0.5, 0.4im, 0.3, 0.2])
p3 = pmrand(4)
sp = sprand(4, 4, 0.3)
v = [0.5, 0.3im, 0.2, 1.0]

@testset "basic" begin
    @test_throws DimensionMismatch PermMatrix([1, 4, 2, 3], [0.1, 0.2, 0.4im])
    @test_throws ArgumentError size(p1, 0)
    @test size(p1, 3) == 1
    @test [zip(findnz(p1)...)...] == [IterNz(p1)...]
    @test p1 == copy(p1)
    @test hash(p1) == hash(copy(p1))
    @test hash(p1) != hash(p2)
    @test eltype(p1) == ComplexF64
    @test eltype(p2) == Float64
    @test eltype(p3) == Float64
    @test size(p1) == (4, 4)
    @test size(p3) == (4, 4)
    @test size(p1, 1) == size(p1, 2) == 4
    @test Matrix(p1) == [0.1 0 0 0; 0 0 0 0.2; 0 0.4im 0 0; 0 0 0.5 0]
    p0 = similar(p1)
    @test p0.perm == p1.perm
    @test p0.perm !== p1.perm
    @test p0.vals !== p1.vals
    @test p1[2, 2] === 0.0im
    @test p1[1, 1] === 0.1 + 0.0im
    copyto!(p0, p1)
    @test p0 == p1
    @test PermMatrix([0.0 -1.0im; 1.0im 0.0im]) ≈ [0.0 -1.0im; 1.0im 0.0im]
end

@testset "linalg" begin
    @test inv(p1) * p1 ≈ Matrix(I, 4, 4)
    @test p1 * transpose(p1) == diagm(0 => p1.vals .^ 2)
    #@test p1*adjoint(p1) == diagm(0=>abs.(p1.vals).^2)
    #@test all(isapprox.(adjoint(p3), transpose(conj(Matrix(p3)))))
    @test p1 * p1' == diagm(0 => abs.(p1.vals) .^ 2)
    @test all(isapprox.(p3', transpose(conj(Matrix(p3)))))
end

@testset "mul" begin
    @test p3 * p2 == SparseMatrixCSC(p3) * p2 == Matrix(p3) * p2

    # Multiply vector
    @test p3 * v == Matrix(p3) * v
    @test v' * p3 == v' * Matrix(p3)
    @test p3 * collect(1:4) == p3.perm .* p3.vals

    # Diagonal matrices
    Dv = Diagonal(v)
    @test p3 * Dv == Matrix(p3) * Dv
    @test Dv * p3 == Dv * Matrix(p3)
end

@testset "elementary" begin
    @test all(isapprox.(conj(p1), conj(Matrix(p1))))
    @test all(isapprox.(real(p1), real(Matrix(p1))))
    @test all(isapprox.(imag(p1), imag(Matrix(p1))))
end

@testset "basicmath" begin
    @test p1 * 2 == Matrix(p1) * 2
    @test p1 / 2 == Matrix(p1) / 2
end

@testset "memorysafe" begin
    @test p1 == PermMatrix([1, 4, 2, 3], [0.1, 0.2, 0.4im, 0.5])
    @test p2 == PermMatrix([2, 1, 4, 3], [0.1, 0.2, 0.4, 0.5])
    @test v == [0.5, 0.3im, 0.2, 1.0]
end

@testset "one and zero" begin
    z = zero(p1)
    @test typeof(z) == typeof(p1)
    @test Matrix(z) == zeros(ComplexF64, 4, 4)

    o = one(p1)
    @test typeof(o) == typeof(p1)
    @test Matrix(o) == Matrix{ComplexF64}(I, 4, 4)
end

@testset "sparse" begin
    Random.seed!(2)
    pm = pmrand(10)
    out = zeros(10, 10)
    @test LuxurySparse.nnz(pm) == 10
    @test LuxurySparse.findnz(pm)[3] == pm.vals
end

@testset "identity sparse" begin
    p1 = Diagonal(randn(10))
    @test length(LuxurySparse.IterNz(p1)) == 10
    @test map(x -> x[3], LuxurySparse.IterNz(p1)) == p1.diag
end

@testset "setindex" begin
    pm = PermMatrix([3, 2, 4, 1], [0.0, 0.0, 0.0, 0.0])
    pm[3, 4] = 1.0
    @test_throws AssertionError pm[3, 1] = 1.0
    @test pm[3, 4] == 1.0
end

@testset "broadcast" begin
    pm = PermMatrix([3, 2, 4, 1], [0.2, 0.6, 0.1, 0.3])
    res = pm .* 3im
    @test res == PermMatrix([3, 2, 4, 1], [0.2, 0.6, 0.1, 0.3] .* 3im) && res isa PermMatrix
end

@testset "fix dense-perm multiplication" begin
    A = randn(ComplexF64, 4, 4)
    pm = PermMatrix([3, 2, 4, 1], [0.2im, 0.6im, 0.1, 0.3])
    @test A * pm ≈ A * Matrix(pm)
end

"""
    IMatrix{Tv}

    IMatrix(n) -> IMatrix
    IMatrix(A::AbstractMatrix{T}) where T -> IMatrix

Represents the Identity matrix with size `n`. `Int64` is its default type. Both `*` and `kron` are optimized.

# Example

```julia-repl
julia> IMatrix(4)
4×4 IMatrix{Bool}:
 1  0  0  0
 0  1  0  0
 0  0  1  0
 0  0  0  1

julia> IMatrix(rand(4,4))
4×4 IMatrix{Float64}:
 1.0  0.0  0.0  0.0
 0.0  1.0  0.0  0.0
 0.0  0.0  1.0  0.0
 0.0  0.0  0.0  1.0

```
"""
struct IMatrix{Tv} <: AbstractMatrix{Tv}
    n::Int
end
IMatrix(n::Integer) = IMatrix{Bool}(n)

Base.size(A::IMatrix, i::Int) = (@assert i == 1 || i == 2; A.n)
Base.size(A::IMatrix) = (A.n, A.n)
Base.getindex(::IMatrix{T}, i::Integer, j::Integer) where {T} = convert(T, i == j)

Base.:(==)(d1::IMatrix, d2::IMatrix) = d1.n == d2.n
Base.isapprox(d1::IMatrix, d2::IMatrix; kwargs...) = d1 == d2

Base.similar(A::IMatrix{Tv}, ::Type{T}) where {Tv,T} = IMatrix{T}(A.n)
Base.one(A::IMatrix{T}) where {T} = IMatrix{T}(A.n)
function Base.copyto!(A::IMatrix, B::IMatrix)
    if A.n != B.n
        throw(DimensionMismatch("matrix dimension mismatch, got $(A.n) and $(B.n)"))
    end
    A
end
LinearAlgebra.ishermitian(D::IMatrix) = true

####### sparse matrix ######
SparseArrays.nnz(M::IMatrix) = M.n
SparseArrays.findnz(M::IMatrix{T}) where {T} = (collect(1:M.n), collect(1:M.n), ones(T, M.n))

using Test
using LinearAlgebra, SparseArrays, Random
using LuxurySparse

Random.seed!(2)

p1 = IMatrix(4)
sp = sprand(ComplexF64, 4, 4, 0.5)
ds = rand(ComplexF64, 4, 4)
pm = PermMatrix([2, 3, 4, 1], randn(4))
v = [0.5, 0.3im, 0.2, 1.0]
dv = Diagonal(v)

@testset "invdet" begin
    ####### linear algebra  ######
    @test inv(p1) == inv(Matrix(p1))
    @test det(p1) == det(Matrix(p1))
    @test diag(p1) == diag(Matrix(p1))
    @test logdet(p1) == 0
    @test inv(pm) == inv(Matrix(pm))
end

@testset "multiply" begin
    for source_ in Any[p1, sp, ds, dv, pm]
        for target in Any[p1, sp, ds, dv, pm]
            for source in Any[source_, source_', transpose(source_)]
                @test (source == target) == (Matrix(source) == Matrix(target))
                @test (source == target) ≈ (Matrix(source) ≈ Matrix(target))
                # *
                lres = source * target
                rres = target * source
                flres = Matrix(source) * Matrix(target)
                frres = Matrix(target) * Matrix(source)
                @test lres ≈ flres
                @test rres ≈ frres
                if !(target === p1 || parent(source) === p1)
                    @test eltype(lres) == eltype(flres)
                    @test eltype(rres) == eltype(frres)
                end

                # +, -
                lres2 = source + target
                rres2 = target - source
                flres2 = Matrix(source) + Matrix(target)
                frres2 = Matrix(target) - Matrix(source)
                @test lres2 ≈ flres2
                @test rres2 ≈ frres2
            end
        end
    end
end

@testset "mul-vector" begin
    # permutation multiply
    lres = transpose(conj(v)) * pm  #! v' not realized!
    rres = pm * v
    flres = v' * Matrix(pm)
    frres = Matrix(pm) * v
    @test lres == flres
    @test rres == frres
    @test eltype(lres) == eltype(flres)
    @test eltype(rres) == eltype(frres)

    # IMatrix
    @test v' * p1 == v'
    @test p1 * v == v
end

@testset "sparse-diag" begin
    N = 100
    dg = Diagonal(randn(ComplexF64, 1000))
    sp = SparseMatrixCSC(dg)
    @test sp * dg == sp * sp
    @test dg * sp == sp * sp
end


@testset "randn" begin
    Random.seed!(2)
    T = ComplexF64
    for m in Any[sprand(T, 5, 5, 0.5)]
        zm = zero(m)
        @test zm ≈ zeros(T, 5, 5)
        if VERSION < v"1.4.0"
            rand!(zm)
            @test !(zm ≈ zeros(T, 5, 5))
            zm = zero(m)
            randn!(zm)
            @test !(zm ≈ zeros(T, 5, 5))
        end
    end
    for m in Any[pmrand(T, 5), Diagonal(randn(T, 5))]
        zm = zero(m)
        @test zm ≈ zeros(T, 5, 5)
        LuxurySparse.randomize!(zm)
        @test !(zm ≈ zeros(T, 5, 5))
        zm = zero(m)
        LuxurySparse.randomize!(zm)
        @test !(zm ≈ zeros(T, 5, 5))
    end
end

@testset "multiply rectangular matrix" begin
    pm = pmrand(4)
    sp = sparse(reshape([1.0 2 3 4], 4, 1))
    res = pm * sp
    @test res ≈ Matrix(pm) * Matrix(sp)
end

@testset "findnz" begin
    for m in Any[p1, sp, ds, dv, pm]
        for _m in Any[m, staticize(m)]
            out = zeros(eltype(m), size(m)...)
            for (i, j, v) in LuxurySparse.IterNz(_m)
                out[i, j] = v
            end
            @test out ≈ m
        end
    end
end

@testset "fallback-issue#Yao#127" begin
    pm = pmrand(512)
    sp = sprand(512, 512, 0.05)
    @test nnz(pm * sp - SparseMatrixCSC(pm) * sp) == 0
end

@testset "regression test" begin
    pop = sparse([2, 3], [4, 5], [1, √2], 5, 5)
    zop = Diagonal([0, 1 / 2, 1, -1 / 2, 0])
    @test (pop*zop)[2, 4] == -0.5
end

@testset "extra" begin
    out = zeros(ComplexF64, 4, 4)
    a = pmrand(4)
    b = pmrand(4)
    mul!(out, a, b, 1, 0)
    @test out ≈ Matrix(a) * Matrix(b)
end

# IMatrix
for func in (:conj, :real, :transpose, :adjoint, :copy)
    @eval (Base.$func)(M::IMatrix{T}) where {T} = IMatrix{T}(M.n)
end
for func in (:adjoint!, :transpose!)
    @eval (LinearAlgebra.$func)(M::IMatrix) = M
end
Base.imag(M::IMatrix{T}) where {T} = Diagonal(zeros(T, M.n))

# PermMatrix
for func in (:conj, :real, :imag)
    @eval (Base.$func)(M::AbstractPermMatrix) = basetype(M)(M.perm, ($func)(M.vals))
end
Base.copy(M::AbstractPermMatrix) = basetype(M)(copy(M.perm), copy(M.vals))
Base.conj!(M::AbstractPermMatrix) = (conj!(M.vals); M)

function Base.transpose(M::AbstractPermMatrix)
    new_perm = fast_invperm(M.perm)
    return basetype(M)(new_perm, M.vals[new_perm])
end

Base.adjoint(S::AbstractPermMatrix{<:Real}) = transpose(S)
Base.adjoint(S::AbstractPermMatrix{<:Complex}) = conj!(transpose(S))

# scalar
Base.:*(A::IMatrix{T}, B::Number) where {T} = Diagonal(fill(promote_type(T, eltype(B))(B), A.n))
Base.:*(B::Number, A::IMatrix{T}) where {T} = Diagonal(fill(promote_type(T, eltype(B))(B), A.n))
Base.:/(A::IMatrix{T}, B::Number) where {T} =
    Diagonal(fill(promote_type(T, eltype(B))(1 / B), A.n))

Base.:*(A::AbstractPermMatrix, B::Number) = basetype(A)(A.perm, A.vals * B)
Base.:*(B::Number, A::AbstractPermMatrix) = A * B
Base.:/(A::AbstractPermMatrix, B::Number) = basetype(A)(A.perm, A.vals / B)
#+(A::PermMatrix, B::PermMatrix) = PermMatrix(A.dv+B.dv, A.ev+B.ev)
#-(A::PermMatrix, B::PermMatrix) = PermMatrix(A.dv-B.dv, A.ev-B.ev)

for op in [:+, :-]
    for MT in [:IMatrix, :AbstractPermMatrix]
        @eval begin
            # IMatrix, PermMatrix - SparseMatrixCSC
            Base.$op(A::$MT, B::SparseMatrixCSC) = $op(SparseMatrixCSC(A), B)
            Base.$op(B::SparseMatrixCSC, A::$MT) = $op(B, SparseMatrixCSC(A))
        end
    end
    @eval begin
        # IMatrix, PermMatrix - Diagonal
        Base.$op(d1::IMatrix, d2::Diagonal) = Diagonal($op(diag(d1), d2.diag))
        Base.$op(d1::Diagonal, d2::IMatrix) = Diagonal($op(d1.diag, diag(d2)))
        Base.$op(d1::AbstractPermMatrix, d2::Diagonal) = $op(SparseMatrixCSC(d1), d2)
        Base.$op(d1::Diagonal, d2::AbstractPermMatrix) = $op(d1, SparseMatrixCSC(d2))
        # PermMatrix - IMatrix
        Base.$op(A::AbstractPermMatrix, B::IMatrix) = $op(SparseMatrixCSC(A), SparseMatrixCSC(B))
        Base.$op(A::IMatrix, B::AbstractPermMatrix) = $op(SparseMatrixCSC(A), SparseMatrixCSC(B))
        Base.$op(A::AbstractPermMatrix, B::AbstractPermMatrix) = $op(SparseMatrixCSC(A), SparseMatrixCSC(B))
    end
end
# NOTE: promote to integer
Base.:+(d1::IMatrix{Ta}, d2::IMatrix{Tb}) where {Ta,Tb} =
    d1 == d2 ? Diagonal(fill(promote_type(Ta, Tb, Int)(2), d1.n)) : throw(DimensionMismatch())
Base.:-(d1::IMatrix{Ta}, d2::IMatrix{Tb}) where {Ta,Tb} =
    d1 == d2 ? spzeros(promote_type(Ta, Tb), d1.n, d1.n) : throw(DimensionMismatch())

for MT in [:IMatrix, :AbstractPermMatrix]
    @eval Base.:(==)(A::$MT, B::SparseMatrixCSC) = SparseMatrixCSC(A) == B
    @eval Base.:(==)(A::SparseMatrixCSC, B::$MT) = A == SparseMatrixCSC(B)
end
Base.:(==)(d1::IMatrix, d2::Diagonal) = all(isone, d2.diag)
Base.:(==)(d1::Diagonal, d2::IMatrix) = all(isone, d1.diag)
Base.:(==)(d1::AbstractPermMatrix, d2::Diagonal) = SparseMatrixCSC(d1) == SparseMatrixCSC(d2)
Base.:(==)(d1::Diagonal, d2::AbstractPermMatrix) = SparseMatrixCSC(d1) == SparseMatrixCSC(d2)
Base.:(==)(A::IMatrix, B::AbstractPermMatrix) = SparseMatrixCSC(A) == SparseMatrixCSC(B)
Base.:(==)(A::AbstractPermMatrix, B::IMatrix) = SparseMatrixCSC(A) == SparseMatrixCSC(B)

for MT in [:IMatrix, :AbstractPermMatrix]
    @eval Base.isapprox(A::$MT, B::SparseMatrixCSC; kwargs...) = isapprox(SparseMatrixCSC(A), B)
    @eval Base.isapprox(A::SparseMatrixCSC, B::$MT; kwargs...) = isapprox(A, SparseMatrixCSC(B))
    @eval Base.isapprox(d1::$MT, d2::Diagonal; kwargs...) = isapprox(diag(d1), d2.diag)
    @eval Base.isapprox(d1::Diagonal, d2::$MT; kwargs...) = isapprox(d1.diag, diag(d2))
end
Base.isapprox(A::IMatrix, B::AbstractPermMatrix; kwargs...) = isapprox(SparseMatrixCSC(A), SparseMatrixCSC(B); kwargs...)
Base.isapprox(A::AbstractPermMatrix, B::IMatrix; kwargs...) = isapprox(SparseMatrixCSC(A), SparseMatrixCSC(B); kwargs...)

abstract type AbstractPermMatrix{Tv, Ti} <: AbstractMatrix{Tv} end
"""
    PermMatrix{Tv, Ti}(perm::AbstractVector{Ti}, vals::AbstractVector{Tv}) where {Tv, Ti<:Integer}
    PermMatrix(perm::Vector{Ti}, vals::Vector{Tv}) where {Tv, Ti}
    PermMatrix(ds::AbstractMatrix)

PermMatrix represents a special kind of linear operator: Permute and Multiply, which means `M * v = v[perm] * val`
Optimized implementations of `inv` and `*` make it much faster than `SparseMatrixCSC`.

* `perm` is the permutation order,
* `vals` is the multiplication factor.

[Generalized Permutation Matrix](https://en.wikipedia.org/wiki/Generalized_permutation_matrix)

# Example

```julia-repl
julia> PermMatrix([2,1,4,3], rand(4))
4×4 SDPermMatrix{Float64, Int64, Vector{Float64}, Vector{Int64}}:
 0.0       0.182251  0.0      0.0
 0.887485  0.0       0.0      0.0
 0.0       0.0       0.0      0.182831
 0.0       0.0       0.22895  0.0

```
"""
struct PermMatrix{Tv,Ti<:Integer,Vv<:AbstractVector{Tv},Vi<:AbstractVector{Ti}} <:
       AbstractPermMatrix{Tv,Ti}
    perm::Vi   # new orders
    vals::Vv   # multiplied values.

    function PermMatrix{Tv,Ti,Vv,Vi}(
        perm::Vi,
        vals::Vv,
    ) where {Tv,Ti<:Integer,Vv<:AbstractVector{Tv},Vi<:AbstractVector{Ti}}
        if length(perm) != length(vals)
            throw(
                DimensionMismatch(
                    "permutation ($(length(perm))) and multiply ($(length(vals))) length mismatch.",
                ),
            )
        end
        new{Tv,Ti,Vv,Vi}(perm, vals)
    end
end
basetype(pm::PermMatrix) = PermMatrix
Base.getindex(M::PermMatrix{Tv}, i::Integer, j::Integer) where {Tv} =
    M.perm[i] == j ? M.vals[i] : zero(Tv)
function Base.setindex!(M::PermMatrix, val, i::Integer, j::Integer)
    @assert M.perm[i] == j "Can not set index due to the absense of entry: ($i, $j)"
    @inbounds M.vals[i] = val
end

# the column major version of `PermMatrix`
struct PermMatrixCSC{Tv,Ti<:Integer,Vv<:AbstractVector{Tv},Vi<:AbstractVector{Ti}} <:
       AbstractPermMatrix{Tv,Ti}
    perm::Vi   # new orders
    vals::Vv   # multiplied values.

    function PermMatrixCSC{Tv,Ti,Vv,Vi}(
        perm::Vi,
        vals::Vv,
    ) where {Tv,Ti<:Integer,Vv<:AbstractVector{Tv},Vi<:AbstractVector{Ti}}
        if length(perm) != length(vals)
            throw(
                DimensionMismatch(
                    "permutation ($(length(perm))) and multiply ($(length(vals))) length mismatch.",
                ),
            )
        end
        new{Tv,Ti,Vv,Vi}(perm, vals)
    end
end
basetype(pm::PermMatrixCSC) = PermMatrixCSC
@propagate_inbounds function Base.getindex(M::PermMatrixCSC{Tv}, i::Integer, j::Integer) where {Tv}
    @boundscheck 0 < j <= size(M, 2)
    @inbounds M.perm[j] == i ? M.vals[j] : zero(Tv)
end
function Base.setindex!(M::PermMatrixCSC, val, i::Integer, j::Integer)
    @assert M.perm[j] == i "Can not set index due to the absense of entry: ($i, $j)"
    @inbounds M.vals[j] = val
end

for MT in [:PermMatrix, :PermMatrixCSC]
    @eval begin
        function $MT{Tv,Ti}(perm, vals) where {Tv,Ti<:Integer}
            $MT{Tv,Ti,Vector{Tv},Vector{Ti}}(Vector{Ti}(perm), Vector{Tv}(vals))
        end

        function $MT(
            perm::Vi,
            vals::Vv,
        ) where {Tv,Ti<:Integer,Vv<:AbstractVector{Tv},Vi<:AbstractVector{Ti}}
            $MT{Tv,Ti,Vv,Vi}(perm, vals)
        end
    end
end
Base.zero(pm::AbstractPermMatrix) = basetype(pm)(pm.perm, zero(pm.vals))
Base.one(pm::AbstractPermMatrix) =
    basetype(pm)(typeof(pm.perm)(1:length(pm.perm)), one.(pm.vals))
Base.similar(x::AbstractPermMatrix{Tv,Ti}) where {Tv,Ti} =
    typeof(x)(copy(x.perm), similar(x.vals))
Base.similar(x::AbstractPermMatrix{Tv,Ti}, ::Type{T}) where {Tv,Ti,T} =
    basetype(x){T,Ti}(copy(x.perm), similar(x.vals, T))

################# Comparison ##################
Base.:(==)(d1::AbstractPermMatrix, d2::AbstractPermMatrix) = SparseMatrixCSC(d1) == SparseMatrixCSC(d2)
Base.isapprox(d1::AbstractPermMatrix, d2::AbstractPermMatrix; kwargs...) = isapprox(SparseMatrixCSC(d1), SparseMatrixCSC(d2); kwargs...)
Base.copyto!(A::AbstractPermMatrix, B::AbstractPermMatrix) =
    (copyto!(A.perm, B.perm); copyto!(A.vals, B.vals); A)

################# Array Functions ##################

Base.size(M::AbstractPermMatrix) = (length(M.perm), length(M.perm))
function Base.size(A::AbstractPermMatrix, d::Integer)
    if d < 1
        throw(ArgumentError("dimension must be ≥ 1, got $d"))
    elseif d <= 2
        return length(A.perm)
    else
        return 1
    end
end

"""
    pmrand(T::Type, n::Int) -> PermMatrix

Return a random [`PermMatrix`](@ref) with type `T`, `n` rows and `n` columns.

# Example

```julia-repl
julia> pmrand(ComplexF64, 4)
4×4 SDPermMatrix{ComplexF64, Int64, Vector{ComplexF64}, Vector{Int64}}:
        0.0+0.0im      0.112104+0.0179632im       0.0+0.0im              0.0+0.0im
 -0.0625997+1.00664im       0.0+0.0im             0.0+0.0im              0.0+0.0im
        0.0+0.0im           0.0+0.0im             0.0+0.0im       -0.0981836-0.839471im
        0.0+0.0im           0.0+0.0im        0.735853-0.747084im         0.0+0.0im

```
"""
function pmrand end

pmrand(::Type{T}, n::Int) where {T} = PermMatrix(randperm(n), randn(T, n))
pmrand(n::Int) = pmrand(Float64, n)

pmcscrand(::Type{T}, n::Int) where {T} = PermMatrixCSC(randperm(n), randn(T, n))
pmcscrand(n::Int) = pmcscrand(Float64, n)

Base.show(io::IO, ::MIME"text/plain", M::AbstractPermMatrix) = show(io, M)
function Base.show(io::IO, M::AbstractPermMatrix)
    n = size(M, 1)
    println(io, typeof(M))
    nmax = 20
    for (k, (i, j, p)) in enumerate(IterNz(M))
        if k <= nmax || k > n-nmax
            print(io, "($i, $j) = $p")
            k < n && println(io)
        elseif k == nmax+1
            println(io, "...")
        end
    end
end
Base.hash(pm::AbstractPermMatrix, h::UInt) = hash((pm.perm, pm.vals), h)

######### sparse array interfaces  #########
SparseArrays.nnz(M::AbstractPermMatrix) = length(M.vals)
SparseArrays.findnz(M::PermMatrix) = (collect(1:size(M, 1)), M.perm, M.vals)
SparseArrays.findnz(M::PermMatrixCSC) = (M.perm, collect(1:size(M, 1)), M.vals)

######### Union of static and dynamic matrices ##########
const SDMatrix{T} = Union{Matrix{T},SArray{Shape,T,2,L} where {Shape,L}}
const SDDiagonal{T} = Union{Diagonal{T},SDiagonal{N,T} where N}
const SDVector{T} = Union{Vector{T},SVector{N,T} where N}
const SDPermMatrix{Tv,Ti<:Integer} = PermMatrix{Tv,Ti,<:SDVector{Tv},<:SDVector{Ti}}
const SPermMatrix{N,Tv,Ti<:Integer} = PermMatrix{Tv,Ti,<:SVector{N,Tv},<:SVector{N,Ti}}
const SDPermMatrixCSC{Tv,Ti<:Integer} = PermMatrixCSC{Tv,Ti,<:SDVector{Tv},<:SDVector{Ti}}
const SPermMatrixCSC{N,Tv,Ti<:Integer} = PermMatrixCSC{Tv,Ti,<:SVector{N,Tv},<:SVector{N,Ti}}
const SDSparseMatrixCSC{Tv,Ti} = Union{SparseMatrixCSC{Tv,Ti},SSparseMatrixCSC{Tv,Ti}}

######### staticize ##########
"""
    staticize(A::AbstractMatrix) -> AbastractMatrix

Transform a matrix to a static form by converting its representation to types from StaticArrays.jl.
Enables faster linear algebra operations.
"""
function staticize end
staticize(x) = x # do nothing if it is not defined
staticize(A::AbstractMatrix) = SMatrix{size(A, 1),size(A, 2)}(A)
staticize(A::AbstractVector) = SVector{length(A)}(A)
staticize(A::Diagonal) = SDiagonal{size(A, 1)}((A.diag...,))
staticize(A::PermMatrix) =
    PermMatrix(SVector{size(A, 1)}(A.perm), SVector{size(A, 1)}(A.vals))
staticize(A::PermMatrixCSC) =
    PermMatrixCSC(SVector{size(A, 1)}(A.perm), SVector{size(A, 1)}(A.vals))
function staticize(A::SparseMatrixCSC)
    iszero(A) && return SSparseMatrixCSC(
        A.m,
        A.n,
        SVector{length(A.colptr)}(A.colptr),
        SVector{0,eltype(A.rowval)}(),
        SVector{0,eltype(A.nzval)}(),
    )
    SSparseMatrixCSC(
        A.m,
        A.n,
        SVector{length(A.colptr)}(A.colptr),
        SVector{length(A.rowval)}(A.rowval),
        SVector{length(A.nzval)}(A.nzval),
    )
end

"""
    dynamicize(A::AbstractMatrix) -> AbastractMatrix

Converts matrices dependent on StaticArrays.jl types to Julia-standard ones.
"""
function dynamicize end
dynamicize(x) = x # do nothing if it is not defined
dynamicize(A::SMatrix) = Matrix(A)
dynamicize(A::SVector) = Vector(A)
dynamicize(A::SDiagonal) = Diagonal(Vector(A.diag))
dynamicize(A::PermMatrix) = PermMatrix(Vector(A.perm), Vector(A.vals))
dynamicize(A::PermMatrixCSC) = PermMatrixCSC(Vector(A.perm), Vector(A.vals))
function dynamicize(A::SSparseMatrixCSC)
    SparseMatrixCSC(A.m, A.n, Vector(A.colptr), Vector(A.rowval), Vector(A.nzval))
end

```@meta
CurrentModule = LuxurySparse
```

# LuxurySparse

*A "Luxury" sparse matrix library for julia language.*

[LuxurySparse](https://github.com/QuantumBFS/LuxurySparse.jl) is a Julia package from [QuantumBFS](https://github.com/QuantumBFS). It aims to provide powerful sparse matrix types for Julia, initially motivated by [Quantum Simulation](https://quantumbfs.github.io/Yao.jl/latest/).

It contains
* more sparse matrix types like `IMatrix`, `PermMatrix` and `SparseMatrixCOO`
* high performance type conversion, `kron`, and multiplication operations.

## Manual

```@contents
Pages = [
    "luxurysparse.md",
]
Depth = 1
```

# LuxurySparse

We provide more detailed optimization through a self-defined sparse library which is more efficient for
operations related to quantum gates.

```@autodocs
Modules = [LuxurySparse]
Private = false
Order   = [:module, :constant, :type, :macro, :function]
```

# Tutorial

## Generalized Permutation Matrix

### Example: Control-Y Gate in Quantum simulation
[Generalized permutation matrices](https://en.wikipedia.org/wiki/Generalized_permutation_matrix) are frequently used in fields such as quantum computation and group theory. Here we see an example of Control-Y Gate in matrix form:
```math
\left(\begin{matrix}
1 & 0 & 0 & 0\\
0 & 1 & 0 & 0\\
0 & 0 & 0 & -i\\
0 & 0 & i & 0\\
\end{matrix}\right)
```

We can represent the matrix using a `PermMatrix` type with the following fields:

* `perm`: [1, 2, 4, 3]
* `vals`: [1, 1, -i, i]

Now let's do a benchmark to feel the speed up

```@example permmatrix
using LuxurySparse: PermMatrix
pm = PermMatrix([1,2,4,3], [1,1,-im,im])
```

```julia
using BenchmarkTools
v = randn(4)
@benchmark $pm*$v samples=100000 evals=1000
```
```
BenchmarkTools.Trial: 
  memory estimate:  144 bytes
  allocs estimate:  1
  --------------
  minimum time:     36.789 ns (0.00% GC)
  median time:      38.816 ns (0.00% GC)
  mean time:        49.227 ns (10.20% GC)
  maximum time:     1.629 μs (89.36% GC)
  --------------
  samples:          10000
  evals/sample:     992
```

As a comparison
```julia
sp = SparseMatrixCSC(pm)
@benchmark $sp*$v samples=100000 evals=1000
```
```
BenchmarkTools.Trial: 
  memory estimate:  144 bytes
  allocs estimate:  1
  --------------
  minimum time:     64.578 ns (0.00% GC)
  median time:      65.769 ns (0.00% GC)
  mean time:        74.292 ns (6.80% GC)
  maximum time:     1.419 μs (87.15% GC)
  --------------
  samples:          10000
  evals/sample:     979
```

## Identity Matrix
The identity matrix is static and is defined as:
```
struct IMatrix{Tv} <: AbstractMatrix{Tv} end
```

With this type, the [Kronecker product](https://en.wikipedia.org/wiki/Kronecker_product) operation can be much faster. Now let's see a benchmark

```@example identity
using LuxurySparse: IMatrix
Id = IMatrix{Float64}(1)
B = randn(7,7);
```

```julia
using BenchmarkTools
@benchmark kron($Id, $B) samples=100000 evals=1000
```
```
BenchmarkTools.Trial: 100000 samples with 1000 evaluations.
 Range (min … max):  3.333 ns … 22.667 ns  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     3.417 ns              ┊ GC (median):    0.00%
 Time  (mean ± σ):   3.457 ns ±  0.343 ns  ┊ GC (mean ± σ):  0.00% ± 0.00%

        ▄     █      ▆     ▄      ▅     ▄      ▃     ▃       ▃
  ▆▁▁▁▁▁█▁▁▁▁▁█▁▁▁▁▁▁█▁▁▁▁▁█▁▁▁▁▁▁█▁▁▁▁▁█▁▁▁▁▁▁█▁▁▁▁▁█▁▁▁▁▁▇ █
  3.33 ns      Histogram: log(frequency) by time     3.71 ns <

 Memory estimate: 0 bytes, allocs estimate: 0.
```
As a comparison
```julia
using LinearAlgebra, SparseArrays
spI = sparse(I, 7, 7)
@benchmark kron($spI, $B) samples=100000 evals=1000 seconds=3600
```
```
julia> @benchmark kron($spI, $B) samples=100000 evals=1000 seconds=3600
BenchmarkTools.Trial: 100000 samples with 1000 evaluations.
 Range (min … max):  694.417 ns …  23.188 μs  ┊ GC (min … max):  0.00% …  0.00%
 Time  (median):       1.117 μs               ┊ GC (median):     0.00%
 Time  (mean ± σ):     1.499 μs ± 977.508 ns  ┊ GC (mean ± σ):  28.57% ± 26.68%

       ▃██▃                                                      
  ▃▃▃▄▅████▆▄▃▂▂▂▂▂▂▂▂▂▂▂▂▁▂▁▁▁▁▂▂▂▂▂▂▂▂▂▂▂▂▂▂▂▃▃▃▃▃▃▃▃▃▃▃▃▂▂▂▂ ▃
  694 ns           Histogram: frequency by time         4.23 μs <

 Memory estimate: 7.11 KiB, allocs estimate: 8.

```

With the help of Julia's multiple dispatch, a more performant `kron` operation can be implemented with LuxurySparse's `IMatrix` type versus the standard sparse identity matrix.
